#!/bin/sh
# get the command line args
iter=$1
flag=$2

pbsdir=/data/sep/myfusan/BP2007_covan/PBS/
bindir=/data/sep/myfusan/BP2007_covan/Bin/
pardir=/data/sep/myfusan/BP2007_covan/Par/
datdir=/data/sep/myfusan/BP2007_covan/Shots/
inpdir=/data/sep/myfusan/BP2007_covan/Input/
imgdir=/data/sep/myfusan/BP2007_covan/Img/
moddir=/data/sep/myfusan/BP2007_covan/Mod/
grddir=/data/sep/myfusan/BP2007_covan/Grd/
scrdir=/data/sep/myfusan/BP2007_covan/Scripts/
objdir=/data/sep/myfusan/BP2007_covan/Fobj/
wrkdir=/data/sep/myfusan/BP2007_covan/

# ===============================================================
# define the useful files
svelname=${grddir}/svel_${flag}_${iter}.H
sepsname=${grddir}/seps_${flag}_${iter}.H
sdelname=${grddir}/sdel_${flag}_${iter}.H

bvelname=${moddir}/vp.${flag}_${iter}.H
bepsname=${moddir}/eps.${flag}_${iter}.H
bdelname=${moddir}/del.${flag}_${iter}.H

stplname=${wrkdir}/stplnth_${flag}

iter_in=1
flag_in=lnsh
# do a quardratic fit to search the step length  
f1=`Disfil number=n format='%13.8g' < ${objdir}/fobj_${flag}_${flag_in}_1.H`
f2=`Disfil number=n format='%13.8g' < ${objdir}/fobj_${flag}_${flag_in}_2.H`
f3=`Disfil number=n format='%13.8g' < ${objdir}/fobj_${flag}_${flag_in}_3.H`

a1=0.005
a2=0.01
a3=0.02

up=`echo "(${a2}*${a2}-${a3}*${a3})*${f1} + (${a3}*${a3}-${a1}*${a1})*${f2} + (${a1}*${a1}-${a2}*${a2})*${f3}" | bc -l`
down=`echo "2*((${a2}-${a3})*${f1} + (${a3}-${a1})*${f2} + (${a1}-${a2})*${f3})" | bc -l`
alfa_min=`echo "${up} ${down}" | awk '{printf "%f", $1 / $2}'`

echo ${alfa_min}
