#!/bin/sh

# get the command line args
iter=$1
flag=$2

pbsdir=/data/sep/myfusan/BP2007_covan/PBS/
bindir=/data/sep/myfusan/BP2007_covan/Bin/
pardir=/data/sep/myfusan/BP2007_covan/Par/
datdir=/data/sep/myfusan/BP2007_covan/Shots/
inpdir=/data/sep/myfusan/BP2007_covan/Input/
imgdir=/data/sep/myfusan/BP2007_covan/Img/
grddir=/data/sep/myfusan/BP2007_covan/Grd/
moddir=/data/sep/myfusan/BP2007_covan/Mod/


n4=13
osx=-2000
dsx=1000

bvel=${moddir}/vp.${flag}_${iter}.H
beps=${moddir}/eps.${flag}_${iter}.H
bdel=${moddir}/del.${flag}_${iter}.H
csou=${inpdir}/cvn.csou.H
coef=${inpdir}/cvn.imptable.H
dcef=${inpdir}/cvn.dr_imptbl.H
mpar=${pardir}/tom.p
dimg=${imgdir}/dimg_${flag}_${iter}.H

for f4 in {1..13}
do
  pbsname=${pbsdir}/tombp_${flag}_${iter}_${f4}.pbs
  jobname=tom_${flag}${iter}${f4}
  if [ -f ${pbsname} ];
  then
     echo "File $FILE exists"
     rm -f ${pbsname}
  else
     echo "File $FILE does not exists"
  fi
  data=${datdir}/crec_covan_sx${f4}.H
  dvel=${grddir}/gvel_${flag}_${iter}_sx${f4}.H
  deps=${grddir}/geps_${flag}_${iter}_sx${f4}.H
  ddel=${grddir}/gdel_${flag}_${iter}_sx${f4}.H
  echo "#!/bin/tcsh" >> ${pbsname}
  echo "#PBS -S /bin/tcsh" >> ${pbsname}
  echo "#PBS -l nodes=1:ppn=16" >> ${pbsname}
  echo "#PBS -l walltime=2:00:00" >> ${pbsname}
  echo "#PBS -j oe " >> ${pbsname}
  echo "#PBS -q default " >> ${pbsname}
  echo "#PBS -o /data/sep/myfusan/BP2007_covan/Log" >> ${pbsname}
  echo "#PBS -e /data/sep/myfusan/BP2007_covan/Log" >> ${pbsname}
  echo "#PBS -N ${jobname}"  >> ${pbsname}
  echo 'setenv PBS_O_WORKDIR /data/sep/myfusan/BP2007_covan/'  >> ${pbsname}
  echo 'cd $PBS_O_WORKDIR'  >> ${pbsname}
  echo 'setenv OMP_NUM_THREADS 16 '  >> ${pbsname}
  echo 'setenv PSC_OMP_AFFINITY TRUE '  >> ${pbsname}

  echo "${bindir}/gradient-mpi.x csou=${csou} crec=${data} bvel=${bvel} beps=${beps} bdel=${bdel} dvel=${dvel} deps=${deps} ddel=${ddel} dimg=${dimg} coef=${coef} dcef=${dcef} par=${mpar}" >> ${pbsname}

  chmod 744 ${pbsname}
  qsub ${pbsname}
done

# check if all the migrations finish
job=100
while [ $job -ge 1 ] 
do 
  jobC=`qstat | grep myfusan | grep ${flag} | grep C | wc -l`
  jobR=`qstat | grep myfusan | grep ${flag} | grep R | wc -l`
  jobQ=`qstat | grep myfusan | grep ${flag} | grep Q | wc -l`
  echo "number of jobs in queue C R Q" $jobC $jobR $jobQ
  ((job = $jobR + $jobQ))
  sleep 10
done

# collect all the gradients 
gvelname=${grddir}/gvel_${flag}_${iter}.H
Add ${grddir}/gvel_${flag}_${iter}_sx*.H > ${gvelname}
pyRemove.py ${grddir}/gvel_${flag}_${iter}_sx*.H

gepsname=${grddir}/geps_${flag}_${iter}.H
Add ${grddir}/geps_${flag}_${iter}_sx*.H > ${gepsname} 
pyRemove.py ${grddir}/geps_${flag}_${iter}_sx*.H

gdelname=${grddir}/gdel_${flag}_${iter}.H
Add ${grddir}/gdel_${flag}_${iter}_sx*.H > ${gdelname} 
pyRemove.py ${grddir}/gdel_${flag}_${iter}_sx*.H
