#!/bin/sh

# get the inversion flag
invflag=$1
ster=$2    # starting iteration
nter=$3    # ending   iteration

imgdir=/data/sep/myfusan/BP2007_covan/Img/
objdir=/data/sep/myfusan/BP2007_covan/Fobj/
inpdir=/data/sep/myfusan/BP2007_covan/Input/
moddir=/data/sep/myfusan/BP2007_covan/Mod/
grddir=/data/sep/myfusan/BP2007_covan/Grd/
bindir=/data/sep/myfusan/BP2007_covan/Bin/
pardir=/data/sep/myfusan/BP2007_covan/Par/
scrdir=/data/sep/myfusan/BP2007_covan/Scripts/


# loop over iteration
iter=${ster}
while [ $iter -le ${nter} ]
do

if [ ${iter} -eq 1 ]
then 
  # initialzie the models
  Cp ${inpdir}/init-cvn-vp.H  ${moddir}/vp.${invflag}_1.H 
  Cp ${inpdir}/init-cvn-eps.H ${moddir}/eps.${invflag}_1.H 
  Cp ${inpdir}/init-cvn-del.H ${moddir}/del.${invflag}_1.H 

  # compute the background image
  ${scrdir}/migration1.sh ${iter} ${invflag}
  
  # compute the residual image and the objective function
  ${scrdir}/residual1.sh ${iter} ${invflag} 
fi

# compute the gradient 
${scrdir}/gradient1.sh ${iter} ${invflag} 

# precondition the gradient
${scrdir}/precond_cg1.sh ${iter} ${invflag}

# linesearch to find the step length
${scrdir}/lnsearch_cg1.sh ${iter} ${invflag}

(( iter++ ))
done
