#!/bin/sh

pbsdir=/data/sep/myfusan/BP2007_covan/PBS/
bindir=/data/sep/myfusan/BP2007_covan/Bin/
pardir=/data/sep/myfusan/BP2007_covan/Par/
datdir=/data/sep/myfusan/BP2007_covan/Shots/
moddir=/data/sep/myfusan/BP2007_covan/Input/
imgdir=/data/sep/myfusan/BP2007_covan/Img/

n4=130
osx=-2000
dsx=100

bvel=${moddir}/cvn.Vp.H
beps=${moddir}/cvn.Epsilon.H
bdel=${moddir}/cvn.Delta.H
csou=${moddir}/cvn.csou.H
coef=${moddir}/cvn.imptable.H
mpar=${pardir}/mig.p

for f4 in {1..13}
do
  pbsname=${pbsdir}/mig_true_sx${f4}.pbs
  if [ -f ${pbsname} ];
  then
     echo "File $FILE exists"
     rm -f ${pbsname}
  else
     echo "File $FILE does not exists"
  fi
  data=${datdir}/crec_covan_sx${f4}.H
  target=${imgdir}/bimg_cvn_true_${f4}.H
  echo $data
  echo $target1
  echo "#!/bin/tcsh" >> ${pbsname}
  echo "#PBS -S /bin/tcsh" >> ${pbsname}
  echo "#PBS -l nodes=1:ppn=16" >> ${pbsname}
  echo "#PBS -l walltime=2:00:00" >> ${pbsname}
  echo "#PBS -j oe " >> ${pbsname}
  echo "#PBS -q default " >> ${pbsname}
  echo "#PBS -o /data/sep/myfusan/BP2007/Log" >> ${pbsname}
  echo "#PBS -e /data/sep/myfusan/BP2007/Log" >> ${pbsname}
  echo "#PBS -N ${pbsname/.pbs/}"  >> ${pbsname}
  echo 'setenv PBS_O_WORKDIR /data/sep/myfusan/BP2007/'  >> ${pbsname}
  echo 'cd $PBS_O_WORKDIR'  >> ${pbsname}
  echo 'setenv OMP_NUM_THREADS 16 '  >> ${pbsname}
  echo 'setenv PSC_OMP_AFFINITY TRUE '  >> ${pbsname}

  echo "${bindir}/bwi-wem3d.x csou=${csou} crec=${data} bvel=${bvel} beps=${beps} bdel=${bdel} bimg=${target} coef=${coef} par=${mpar}" >> ${pbsname}

  chmod 744 ${pbsname}
  qsub ${pbsname}
done

# check if all the migrations finish
job=100
while [ $job -ge 1 ] 
do 
  jobC=`qstat | grep myfusan | grep true | grep C | wc -l`
  jobR=`qstat | grep myfusan | grep true | grep R | wc -l`
  jobQ=`qstat | grep myfusan | grep true | grep Q | wc -l`
  echo "number of jobs in queue C R Q" $jobC $jobR $jobQ
  ((job = $jobR + $jobQ))
  sleep 10
done

# collect all the images
bimgname=${imgdir}/bimg_cvn_true.H
Add ${imgdir}/bimg_cvn_true_*.H > ${bimgname} 
pyRemove.py ${imgdir}/bimg_cvn_true_*.H 

