#!/bin/sh

# get the command line args

iter=$1
flag=$2

if [ "$#" -eq 3 ]; then
flg2=$3
fi

pbsdir=/data/sep/myfusan/BP2007_covan/PBS/
bindir=/data/sep/myfusan/BP2007_covan/Bin/
pardir=/data/sep/myfusan/BP2007_covan/Par/
datdir=/data/sep/myfusan/BP2007_covan/Shots/
inpdir=/data/sep/myfusan/BP2007_covan/Input/
imgdir=/data/sep/myfusan/BP2007_covan/Img/
moddir=/data/sep/myfusan/BP2007_covan/Mod/

n4=13
osx=-2000
dsx=1000


if [ "$#" -eq 2 ]; then
  bvel=${moddir}/vp.${flag}_${iter}.H
  beps=${moddir}/eps.${flag}_${iter}.H
  bdel=${moddir}/del.${flag}_${iter}.H
else if [ "$#" -eq 3 ]; then
  bvel=${moddir}/vp.${flg2}_${flag}_${iter}.H
  beps=${moddir}/eps.${flg2}_${flag}_${iter}.H
  bdel=${moddir}/del.${flg2}_${flag}_${iter}.H
fi 
fi

csou=${inpdir}/cvn.csou.H
coef=${inpdir}/cvn.imptable.H
mpar=${pardir}/mig.p

for f4 in {1..13}
do
  data=${datdir}/crec_covan_sx${f4}.H
  if [ "$#" -eq 2 ]; 
  then
    pbsname=${pbsdir}/migbp_${flag}_${iter}_${f4}.pbs
    jobname=mig${flag}${iter}${f4}
    target=${imgdir}/bimg_${flag}_${iter}_${f4}.H
  fi
  if [ "$#" -eq 3 ]; then
  echo "in lnsh"
    pbsname=${pbsdir}/migbp_${flg2}_${flag}_${iter}_${f4}.pbs
    jobname=mig${flg2}${iter}${f4}
    target=${imgdir}/bimg_${flg2}_${flag}_${iter}_${f4}.H
  fi
  if [ -f ${pbsname} ];
  then
     echo "File $FILE exists"
     rm -f ${pbsname}
  else
     echo "File $FILE does not exists"
  fi

  echo $target1
  echo "#!/bin/tcsh" >> ${pbsname}
  echo "#PBS -S /bin/tcsh" >> ${pbsname}
  echo "#PBS -l nodes=1:ppn=16" >> ${pbsname}
  echo "#PBS -l walltime=2:00:00" >> ${pbsname}
  echo "#PBS -j oe " >> ${pbsname}
  echo "#PBS -q default " >> ${pbsname}
  echo "#PBS -o /data/sep/myfusan/BP2007_covan/Log" >> ${pbsname}
  echo "#PBS -e /data/sep/myfusan/BP2007_covan/Log" >> ${pbsname}
  echo "#PBS -N ${jobname}"  >> ${pbsname}
  echo 'setenv PBS_O_WORKDIR /data/sep/myfusan/BP2007_covan/'  >> ${pbsname}
  echo 'cd $PBS_O_WORKDIR'  >> ${pbsname}
  echo 'setenv OMP_NUM_THREADS 16 '  >> ${pbsname}
  echo 'setenv PSC_OMP_AFFINITY TRUE '  >> ${pbsname}

  echo "${bindir}/BoundAniso.x eps=${beps} del=${bdel}" >> ${pbsname}
  echo "${bindir}/bwi-wem3d.x csou=${csou} crec=${data} bvel=${bvel} beps=${beps} bdel=${bdel} bimg=${target} coef=${coef} par=${mpar}" >> ${pbsname}

  chmod 744 ${pbsname}
  qsub ${pbsname}
done

# check if all the migrations finish
if [ "$#" -eq 2 ]; then
grepflag=${flag}
else if [ "$#" -eq 3 ]; then
grepflag=${flg2}
fi
fi

job=100
while [ $job -ge 1 ] 
do 
  jobC=`qstat | grep myfusan | grep ${grepflag} | grep C | wc -l`
  jobR=`qstat | grep myfusan | grep ${grepflag} | grep R | wc -l`
  jobQ=`qstat | grep myfusan | grep ${grepflag} | grep Q | wc -l`
  echo "number of jobs in queue C R Q" $jobC $jobR $jobQ
  ((job = $jobR + $jobQ))
  sleep 10
done


if [ "$#" -eq 2 ]; then
# collect all the images
  bimgname=${imgdir}/bimg_${flag}_${iter}.H
  Add ${imgdir}/bimg_${flag}_${iter}_*.H > ${bimgname} 
  pyRemove.py ${imgdir}/bimg_${flag}_${iter}_*.H 
else if [ "$#" -eq 3 ]; then
# collect all the images
  bimgname=${imgdir}/bimg_${flg2}_${flag}_${iter}.H
  Add ${imgdir}/bimg_${flg2}_${flag}_${iter}_*.H > ${bimgname} 
  pyRemove.py ${imgdir}/bimg_${flg2}_${flag}_${iter}_*.H 
fi
fi

