#!/bin/sh

pbsdir=/data/sep/myfusan/BP2007_covan/PBS/
bindir=/data/sep/myfusan/BP2007_covan/Bin/
pardir=/data/sep/myfusan/BP2007_covan/Par/
datdir=/data/sep/myfusan/BP2007_covan/Shots/
moddir=/data/sep/myfusan/BP2007_covan/Input/

n4=13
osx=-2000
dsx=1000

bvel=${moddir}/cvn.Vp.H
beps=${moddir}/cvn.Epsilon.H
bdel=${moddir}/cvn.Delta.H
bref=${moddir}/cvn.refl.H
csou=${moddir}/cvn.csou.H
coef=${moddir}/cvn.imptable.H
mpar=${pardir}/mdl.p

for f4 in {1..13}
do
  (( sx = $f4 - 1 ))
  (( sx = sx * $dsx + $osx ))
  echo $sx
  pbsname=${pbsdir}/model_cvn_sx${f4}.pbs
  if [ -f ${pbsname} ];
  then
     echo "File $FILE exists"
     rm -f ${pbsname}
  else
     echo "File $FILE does not exists"
  fi
  data=${datdir}/crec_covan_sx${f4}.H
  echo $data
  #  echo $target1
  echo "#!/bin/tcsh" >> ${pbsname}
  echo "#PBS -S /bin/tcsh" >> ${pbsname}
  echo "#PBS -l nodes=1:ppn=16" >> ${pbsname}
  echo "#PBS -l walltime=2:00:00" >> ${pbsname}
  echo "#PBS -j oe " >> ${pbsname}
  echo "#PBS -q default " >> ${pbsname}
  echo "#PBS -o /data/sep/myfusan/BP2007_covan/Log" >> ${pbsname}
  echo "#PBS -e /data/sep/myfusan/BP2007_covan/Log" >> ${pbsname}
  echo "#PBS -N ${pbsname/.pbs/}"  >> ${pbsname}
  echo 'setenv PBS_O_WORKDIR /data/sep/myfusan/BP2007_covan/'  >> ${pbsname}
  echo 'cd $PBS_O_WORKDIR'  >> ${pbsname}
  echo 'setenv OMP_NUM_THREADS 16 '  >> ${pbsname}
  echo 'setenv PSC_OMP_AFFINITY TRUE '  >> ${pbsname}

  echo "${bindir}/bwi-wem3d.x csou=${csou} crec=${data} bvel=${bvel} beps=${beps} bdel=${bdel} bimg=${bref} coef=${coef} par=${mpar} osx=${sx} nsx=10" >> ${pbsname}

  chmod 744 ${pbsname}
  qsub ${pbsname}
done

