#!/bin/sh

# get the command line args
iter=$1
flag=$2

pbsdir=/data/sep/myfusan/BP2007_covan/PBS/
bindir=/data/sep/myfusan/BP2007_covan/Bin/
pardir=/data/sep/myfusan/BP2007_covan/Par/
datdir=/data/sep/myfusan/BP2007_covan/Shots/
inpdir=/data/sep/myfusan/BP2007_covan/Input/
imgdir=/data/sep/myfusan/BP2007_covan/Img/
moddir=/data/sep/myfusan/BP2007_covan/Mod/
grddir=/data/sep/myfusan/BP2007_covan/Grd/

# ===============================================================
# define the useful files
vmsk=${inpdir}/cvn.maskv.H
emsk=${inpdir}/cvn.maske.H
dmsk=${inpdir}/cvn.maskd.H
stdv=${inpdir}/cvn.${flag}.H
grdprcpar=${pardir}/grdprc-test.p

bimgname=${inpdir}/grdprc.img.H

gvelname=${grddir}/gvel_${flag}_${iter}.H
gepsname=${grddir}/geps_${flag}_${iter}.H
gdelname=${grddir}/gdel_${flag}_${iter}.H

dvelname=${grddir}/dvel_${flag}_${iter}.H
depsname=${grddir}/deps_${flag}_${iter}.H
ddelname=${grddir}/ddel_${flag}_${iter}.H
Math file1=${gvelname} exp="file1*-1." > ${dvelname} 
Math file1=${gepsname} exp="file1*-1." > ${depsname} 
Math file1=${gdelname} exp="file1*-1." > ${ddelname} 
${bindir}/gradprcs-mpi.x gdov=${dvelname} gdoe=${depsname} gdod=${ddelname} vmsk=${vmsk} emsk=${emsk} dmsk=${dmsk} stdv=${stdv} par=${grdprcpar} bimg=${bimgname}

# nonlinear conjugate gradient step
((piter=iter-1))

svelname=${grddir}/svel_${flag}_${iter}.H
sepsname=${grddir}/seps_${flag}_${iter}.H
sdelname=${grddir}/sdel_${flag}_${iter}.H
if [ ${iter} -le 1 ]
then
  Cp ${dvelname} ${svelname} 
  Cp ${depsname} ${sepsname} 
  Cp ${ddelname} ${sdelname} 
else
  psvelname=${grddir}/svel_${flag}_${piter}.H
  psepsname=${grddir}/seps_${flag}_${piter}.H
  psdelname=${grddir}/sdel_${flag}_${piter}.H
  pdvelname=${grddir}/dvel_${flag}_${piter}.H
  pdepsname=${grddir}/deps_${flag}_${piter}.H
  pddelname=${grddir}/ddel_${flag}_${piter}.H
  ${bindir}/NonlnrCG.x cvel=${dvelname} ceps=${depsname} cdel=${ddelname} pgvel=${pdvelname} pgeps=${pdepsname} pgdel=${pddelname} psvel=${psvelname} pseps=${psepsname} psdel=${psdelname} svel=${svelname} seps=${sepsname} sdel=${sdelname}
fi

