program BuildCovan

  use sep

  implicit none

  real, allocatable                     :: eps(:,:,:,:),del(:,:,:,:),vp0(:,:,:,:)
  real, allocatable                     :: Svv(:,:,:),See(:,:,:),Sdd(:,:,:)
  real, allocatable                     :: Sve(:,:,:),Svd(:,:,:),Sed(:,:,:)
  real, allocatable                     :: saltmsk(:,:,:)
  integer                               :: n1out, n2out
  real                                  :: d1, o1, d2, o2, d3, o3, d4, o4
  integer                               :: n1, n2, n3, n4, phi_n, i, iphi
  integer								:: i1, i2, i3, i4, iw
  character(20)                         :: label1, label2, label3
  real									:: mv, me, md 
  real									:: W200_exp, W400_exp, pi=3.1415
  real									:: C11, C12, C13, C33, C44, pcl, pil, pqu, aa, bb, cc
  real									:: M, Nu
  logical								:: mask 


  call sep_init()

  ! Get data dimensions from command line.
  ! z, x, y, nrealization
  call from_history("n1",n1)	           
  call from_history("n2",n2)
  call from_history("n3",n3)
  call from_history("n4",n4)
  call from_history("o1",o1)
  call from_history("o2",o2)
  call from_history("o3",o3)
  call from_history("o4",o4)
  call from_history("d1",d1)
  call from_history("d2",d2)
  call from_history("d3",d3)
  call from_history("d4",d4)

  allocate(eps(n1,n2,n3,n4),del(n1,n2,n3,n4),vp0(n1,n2,n3,n4))
  allocate(Svv(n1,n2,n3)   ,See(n1,n2,n3)   ,Sdd(n1,n2,n3)   )
  allocate(Sve(n1,n2,n3)   ,Svd(n1,n2,n3)   ,Sed(n1,n2,n3)   )
  call sep_read(eps)
  call sreed("del", del, 4*n1*n2*n3*n4)
  call sreed("vp0", vp0, 4*n1*n2*n3*n4)

  call from_param("mask",mask,.false.)
  if (mask) then
		  allocate(saltmsk(n1,n2,n3))
		  call sreed("saltmsk",saltmsk,4*n1*n2*n3)
  end if

  do i1=1,n1
		  do i2=1,n2
				  do i3=1,n3
						  mv = sum(vp0(i1,i2,i3,:))/n4
						  me = sum(eps(i1,i2,i3,:))/n4
						  md = sum(del(i1,i2,i3,:))/n4
						  Svv(i1,i2,i3) = sum((vp0(i1,i2,i3,:)-mv)**2)/n4
						  See(i1,i2,i3) = sum((eps(i1,i2,i3,:)-me)**2)/n4
						  Sdd(i1,i2,i3) = sum((del(i1,i2,i3,:)-md)**2)/n4
						  Sve(i1,i2,i3) = sum((vp0(i1,i2,i3,:)-mv)*(eps(i1,i2,i3,:)-me))/n4
						  Svd(i1,i2,i3) = sum((vp0(i1,i2,i3,:)-mv)*(del(i1,i2,i3,:)-md))/n4
						  Sed(i1,i2,i3) = sum((del(i1,i2,i3,:)-md)*(eps(i1,i2,i3,:)-me))/n4
				  end do
		  end do
  end do
  if (mask) then
		  Svv = Svv * Saltmsk
		  See = See * Saltmsk
		  Sdd = Sdd * Saltmsk
		  Sve = Sve * Saltmsk
		  Svd = Svd * Saltmsk
		  Sed = Sed * Saltmsk
  end if

  call to_history("n1",n1)             
  call to_history("n2",n2)
  call to_history("n3",n3)
  call to_history("n4", 6)
  call to_history("o1",o1)
  call to_history("o2",o2)
  call to_history("o3",o3)
  call to_history("o4", 0)
  call to_history("d1",d1)
  call to_history("d2",d2)
  call to_history("d3",d3)
  call to_history("d4", 1)
  call to_history("esize", 4)

  call sep_write(Svv)
  call sep_write(See)
  call sep_write(Sdd)
  call sep_write(Sve)
  call sep_write(Svd)
  call sep_write(Sed)

  deallocate(eps,del,vp0)
  deallocate(Svv,See,Sdd)
  deallocate(Sve,Svd,Sed)

end program 


