program GetPillite 

  use sep

  implicit none

  real, allocatable                     :: tmprt(:,:,:)
  integer                               :: n1out, n2out
  real                                  :: d1, o1, d2, o2, d3, o3
  integer                               :: n1, n2, n3, i1, i2, i3
  character(20)                         :: label1, label2, label3
  real									:: ttrsit, ltrsit 
  integer                      :: ompchunk, nth
  integer  ,          external :: omp_get_num_procs
  integer  ,          external :: omp_get_num_threads
  integer  ,          external :: omp_set_num_threads
  integer  ,          external :: omp_get_thread_num

  call sep_init()

  ! Get data dimensions from command line.
  call from_history("n1",n1)	           
  call from_history("n2",n2)
  call from_history("n3",n3)
  call from_history("o1",o1)
  call from_history("o2",o2)
  call from_history("o3",o3)
  call from_history("d1",d1)
  call from_history("d2",d2)
  call from_history("d3",d3)

  ! get the transition temperature and length of the transition zone from command line 
  ! from averaging the data in Freed and Peacor 1989
  call from_param("ttrsit", ttrsit, 81.)
  call from_param("ltrsit", ltrsit, 33.)

  allocate(tmprt(n1, n2, n3))
  call sep_read(tmprt)

  tmprt = tmprt - ttrsit; tmprt = tmprt / (2*ltrsit);
  tmprt = 0.5 + 0.5*tanh(tmprt)

  call to_history("n1",n1)             
  call to_history("n2",n2)
  call to_history("n3",n3)
  call to_history("o1",o1)
  call to_history("o2",o2)
  call to_history("o3",o3)
  call to_history("d1",d1)
  call to_history("d2",d2)
  call to_history("d3",d3)
  call to_history("esize", 4)

  call sep_write(tmprt)
  deallocate(tmprt)

end program 
