program ModPoro 

  use sep

  implicit none

  real, allocatable                     :: vel(:,:,:), poro(:,:,:)
  real, allocatable                     :: pclay(:,:,:)
  integer                               :: n1out, n2out
  real                                  :: d1, o1, d2, o2, d3, o3
  integer                               :: n1, n2, n3, i1, i2, i3
  character(20)                         :: label1, label2, label3
  real									:: wdepth, v
  integer								:: method 
  real									:: iw 


  call sep_init()

  ! Get data dimensions from command line.
  call from_history("n1",n1)	           
  call from_history("n2",n2)
  call from_history("n3",n3)
  call from_history("o1",o1)
  call from_history("o2",o2)
  call from_history("o3",o3)
  call from_history("d1",d1)
  call from_history("d2",d2)
  call from_history("d3",d3)

  ! get the salt velocity from command line
  call from_param("wdepth",wdepth,1.5)
  iw = (wdepth - o1)/d1 + 1

  call from_param("method",method,1)

  allocate(vel(n1,n2,n3),poro(n1,n2,n3))

  call sep_read(vel)

  do i3=1,n3
		  do i2=1,n2
				  do i1=1,n1
						v = vel(i1,i2,i3)/1000.;  
					    poro(i1,i2,i3) = -1.180 + 8.607*(1/v) - 17.89*(1/v)**2 + 13.94*(1/v)**3
						poro(i1,i2,i3) = poro(i1,i2,i3)*0.5;
				  end do	
		  end do
  end do

  call to_history("n1",n1)             
  call to_history("n2",n2)
  call to_history("n3",n3)
  call to_history("o1",o1)
  call to_history("o2",o2)
  call to_history("o3",o3)
  call to_history("d1",d1)
  call to_history("d2",d2)
  call to_history("d3",d3)
  call to_history("esize", 4)

  call sep_write(poro)
  deallocate(poro,vel)

end program 
