program main 

  use sep

  implicit none

  real, allocatable                     :: eta_del(:,:,:)
  real, allocatable                     :: eps_del(:,:,:)
  integer                               :: n1out, n2out
  real                                  :: d1, o1, d2, o2, d3, o3
  integer                               :: n1, n2, n3, neps
  integer								:: i1, i2, i3, ieps
  character(20)                         :: label1, label2, label3
  real									:: eps_max, eps_min, eps_d, eps 
  real									:: eta_max, eta_min, eta_d, eta 
  real									:: del_max, del_min, del_d, del 


  call sep_init()

  ! Get data dimensions from command line.
  call from_history("n1",n1)	           
  call from_history("n2",n2)
  call from_history("n3",n3)
  call from_history("o1",o1)
  call from_history("o2",o2)
  call from_history("o3",o3)
  call from_history("d1",d1)
  call from_history("d2",d2)
  call from_history("d3",d3)

  eta_min = o2; eta_max = o2 + (n2-1)*d2
  del_min = o1; del_max = o1 + (n1-1)*d1
  eps_min = del_min + (1+2*del_min)*eta_min;
  eps_max = del_max + (1+2*del_max)*eta_max;
  call from_param("eps_d",eps_d,d2)
  neps = (eps_max - eps_min) / eps_d + 1

  allocate(eta_del(n1,n2,n3),eps_del(n1,neps,n3))
  call sep_read(eta_del)

  do i3=1,n3
	do ieps=1,neps
	  do i1=1,n1
		eps = eps_min + (ieps-1)*eps_d
		del = o1 + (i1-1)* d1
		eta = (eps-del)/(1+2*del)
		i2 = (eta-o2)/d2 + 1
		if (i2>n2) i2=n2
		if (i2<1)  i2=1
!		write(0,*) eps,del,eta,i2
		eps_del(i1,ieps,i3) = eta_del(i1,i2,i3)
      end do
    end do
  end do

  call to_history("n1",n1)             
  call to_history("n2",neps)
  call to_history("n3",n3)
  call to_history("o1",o1)
  call to_history("o2",eps_min)
  call to_history("o3",o3)
  call to_history("d1",d1)
  call to_history("d2",eps_d)
  call to_history("d3",d3)
  call to_history("esize", 4)
  call to_history("label2", "epsilon")

  call sep_write(eps_del)

  deallocate(eta_del, eps_del)

end program 


