program SaltMask 

  use sep

  implicit none

  real, allocatable                     :: den(:,:,:), mask(:,:,:)
  integer                               :: n1out, n2out
  real                                  :: d1, o1, d2, o2, d3, o3
  integer                               :: n1, n2, n3
  character(20)                         :: label1, label2, label3
  real									:: rho_salt


  call sep_init()

  ! Get data dimensions from command line.
  call from_history("n1",n1)	           
  call from_history("n2",n2)
  call from_history("n3",n3)
  call from_history("o1",o1)
  call from_history("o2",o2)
  call from_history("o3",o3)
  call from_history("d1",d1)
  call from_history("d2",d2)
  call from_history("d3",d3)

  ! get the salt velocity from command line
  call from_param("rhosalt",rho_salt,2.1)


  allocate(den(n1, n2, n3),mask(n1, n2,n3))
  call sep_read(den)
  call sreed("mask",mask,4*n1*n2*n3)

  where (mask==0) den=rho_salt 

  call to_history("n1",n1)             
  call to_history("n2",n2)
  call to_history("o1",o1)
  call to_history("o2",o2)
  call to_history("d1",d1)
  call to_history("d2",d2)
  call to_history("esize", 4)

  call sep_write(den)
  deallocate(den, mask)

end program 


