program SaltMask 

  use sep

  implicit none

  real, allocatable                     :: vel(:,:,:), mask(:,:,:)
  integer                               :: n1out, n2out
  real                                  :: d1, o1, d2, o2, d3, o3
  integer                               :: n1, n2, n3
  character(20)                         :: label1, label2, label3
  real									:: vsalt


  call sep_init()

  ! Get data dimensions from command line.
  call from_history("n1",n1)	           
  call from_history("n2",n2)
  call from_history("n3",n3)
  call from_history("o1",o1)
  call from_history("o2",o2)
  call from_history("o3",o3)
  call from_history("d1",d1)
  call from_history("d2",d2)
  call from_history("d3",d3)

  ! get the salt velocity from command line
  call from_param("vsalt",vsalt,3900.)


  allocate(vel(n1, n2, n3),mask(n1, n2,n3))
  call sep_read(vel)
  mask = 1.

  where (vel > vsalt) mask=0. 

  call to_history("n1",n1)             
  call to_history("n2",n2)
  call to_history("o1",o1)
  call to_history("o2",o2)
  call to_history("d1",d1)
  call to_history("d2",d2)
  call to_history("esize", 4)

  call sep_write(mask)
  deallocate(vel,mask)

end program 


