#include "math.h"
#include "sgjbase.h"
#include "sgjmig.h"

struct shot_ker_ani_implicit_type shot_ker_ani_implicit_init(int nfdcoe){
  filehead imtable;
  int stat;
  struct shot_ker_ani_implicit_type aniim;
  stat=file_open_input("Implicittable",&imtable);
  aniim.o_dl=imtable.o[1]; aniim.d_dl=imtable.d[1]; aniim.n_dl=imtable.n[1];
  aniim.o_ep=imtable.o[2]; aniim.d_ep=imtable.d[2]; aniim.n_ep=imtable.n[2];
  aniim.nfdcoe=nfdcoe;
  printf("n_ep=%d,n_dl=%d\n",aniim.n_ep,aniim.n_dl);
  aniim.fdcoe=allocate_f3(aniim.n_ep,aniim.n_dl,nfdcoe);
  if (sreed("Implicittable",**(aniim.fdcoe),aniim.n_ep*aniim.n_dl*nfdcoe*4)!=aniim.n_ep*aniim.n_dl*nfdcoe*4 ) seperr("err read implicit table\n");
  return aniim;
}

void shot_ker_ani_implicit_release(struct shot_ker_ani_implicit_type *aniim){
  free_f3(aniim->fdcoe);
}

void shot_ker_ani_implicit_depth_onestep(__complex__ float *wld_z,float *v_z,float *ep_z,float *dl_z,float w,int signn, struct shot_ker_par_type ker_par, struct shot_ker_ani_implicit_type aniim){
int op,nref,nx,ny,is2d;

float wvx,dref,wvx_all;
__complex__ float  *tmp_fft,*add_wld,*tmp_wld;
int iref,ix,iy,ivx,iiref;
float w_v0_z,maxvz,minvz;
float *v0_z,*v_zw,*v_zw0;
float a01,b01,a02,b02,ep0,dl0;
float v0;
int nsediment;

nref=ker_par.nref;  nx=ker_par.nx;  ny=ker_par.ny;  is2d=ker_par.is2d;  op=ker_par.op; //! op:1:ssf 2:fd 3:ffd
v0_z=ker_par.v0_z; v_zw=ker_par.v_zw; v_zw0=ker_par.v_zw0;
add_wld=ker_par.add_wld; tmp_wld=ker_par.tmp_wld; 

tmp_fft=allocatec(nx*2);
maxvz=maxval(v_z,nx*ny); minvz=minval(v_z,nx*ny);  dref=(maxvz-minvz)/(nref+1);
if ( fabs(maxvz-minvz)<50.0 ) { ///?????????????wait
   nref=1;  v0_z[0]=0.5*(maxvz+minvz);
}
else{
   v0_z[0]=minvz;  v0_z[nref-1]=maxvz;  dref=(v0_z[nref-1]-v0_z[0])/(float)(nref-1); v0_z[1]=(minvz+maxvz)*0.5;  
}
for(ep0=0,ix=0;ix<nx;ix++) ep0+=ep_z[ix];
ep0=ep0/nx;
for(dl0=0,ix=0;ix<nx;ix++) dl0+=dl_z[ix];
dl0=dl0/nx;

for(v0=0,nsediment=0,ix=0;ix<nx;ix++){
  if (v_z[ix]<4000){
    v0+=v_z[ix];
    nsediment++;
  }
}
if (nsediment<50){
  for(v0=0,ix=0;ix<nx;ix++){
    v0+=v_z[ix];
  }
  v0=v0/nx;
  
}
else{
  v0=v0/nsediment;
}


for (iy=0;iy<ny;iy++)
  for(ix=0;ix<nx;ix++)
    v_zw[i2(iy,ix,nx)]=v_z[i2(iy,ix,nx)]/w;
if (op == 2){
  if (maxvz-minvz<=50){
    if (is2d){
      vector_value_c(tmp_fft,cmplx(0.0,0.0),nx);
      rowc(wld_z,tmp_fft,0,nx,1);  //tmp_fft=wld_z(1,:);
      cwpfft1d(tmp_fft,nx,+1);
      rowc(wld_z,tmp_fft,0,nx,0);  //wld_z(1,:)=tmp_fft(:);
    }
    w_v0_z=w/(minvz*0.75+maxvz*0.25);
    shot_ker_ani_implicit_phaseshift(wld_z,w_v0_z,ep0,dl0,ker_par,signn);
    if (is2d){
      rowc(wld_z,tmp_fft,0,nx,1); //tmp_fft=tmp_wld(:,1);
      cwpfft1d(tmp_fft,nx,-1);
      rowc(wld_z,tmp_fft,0,nx,0);  //tmp_wld(:,1)=tmp_fft(:);
    }
    shot_ker_ssf(wld_z,w_v0_z,w,v_z,ker_par,signn);
  }
  else{ 
    
    w_v0_z=0.0;
    shot_ker_ssf(wld_z,w_v0_z,w,v_z,ker_par,signn);
    if (aniim.nfdcoe==2){
      shot_ker_ani_implicit_genaxbx(ep_z,dl_z,&ker_par,aniim,0); 
      shot_ker_ani_implicit_fd(wld_z,v_zw,v_zw,ker_par,signn);
    }
    else
     
    if (is2d){
      vector_value_c(tmp_fft,cmplx(0.0,0.0),nx);
      rowc(wld_z,tmp_fft,0,nx,1);  //tmp_fft=wld_z(1,:);
      cwpfft1d(tmp_fft,nx,+1);
      rowc(wld_z,tmp_fft,0,nx,0);  //wld_z(1,:)=tmp_fft(:);
    }
    shot_ker_ani_implicit_getab(ep0,dl0,&a01,&b01,&a02,&b02,aniim);
    
    matrix_equ_c(tmp_wld,wld_z,ny,nx);
    w_v0_z=w/(0.75*minvz+0.25*maxvz);
    w_v0_z=w/minvz; 
    shot_ker_ani_implicit_li_filter_new(wld_z,w_v0_z,ep0,dl0,a01,b01,a02,b02,ker_par,signn);
    if (is2d){
      rowc(wld_z,tmp_fft,0,nx,1); //tmp_fft=tmp_wld(:,1);
      cwpfft1d(tmp_fft,nx,-1);
      rowc(wld_z,tmp_fft,0,nx,0);  //tmp_wld(:,1)=tmp_fft(:);
    }
    
    
    /*w_v0_z=w/minvz;
    shot_ker_ani_implicit_li_filter_new(tmp_wld,w_v0_z,ep0,dl0,a0,b0,ker_par,signn);
    if (is2d){
      rowc(tmp_wld,tmp_fft,0,nx,1); //tmp_fft=tmp_wld(:,1);
      cwpfft1d(tmp_fft,nx,-1);
      rowc(tmp_wld,tmp_fft,0,nx,0);  //tmp_wld(:,1)=tmp_fft(:);
    }
    for(ix=0;ix<nx;ix++){
      if(v_z[ix]<0.9*minvz+0.1*maxvz){
         wld_z[ix]=tmp_wld[ix];
      }
    }
    */
    
   
  }
  
} 

free(tmp_fft);

}


void shot_ker_ani_implicit_getab(float ep0,float dl0,float *a1,float *b1,float *a2, float *b2, struct shot_ker_ani_implicit_type aniim){
  int i_ep,i_dl;
  float if_ep,if_dl;
  if_ep=(ep0-aniim.o_ep)/aniim.d_ep; if_dl=(dl0-aniim.o_dl)/aniim.d_dl;
  i_ep=(int)(if_ep); i_dl=(int)(if_dl);
  if (if_ep-i_ep>0.5) i_ep++; if (if_dl-i_dl) i_dl++;
  //i_ep=(ep0-aniim.o_ep)/aniim.d_ep; i_dl=(dl0-aniim.o_dl)/aniim.d_dl;
  if (i_ep>=aniim.n_ep || i_ep <0 ) printf("bad\n");
  if (i_dl>=aniim.n_dl || i_dl <0) printf("bad\n");
  if (aniim.nfdcoe==2){
    *a1=aniim.fdcoe[i_ep][i_dl][1]; *b1=aniim.fdcoe[i_ep][i_dl][0];
  }
  else{
  *a1=aniim.fdcoe[i_ep][i_dl][0]; *b1=aniim.fdcoe[i_ep][i_dl][1];
  *a2=aniim.fdcoe[i_ep][i_dl][2]; *b2=aniim.fdcoe[i_ep][i_dl][3];
  }
}

void shot_ker_ani_implicit_genaxbx(float *ep_z,float *dl_z,struct shot_ker_par_type *ker_par,struct shot_ker_ani_implicit_type aniim,int icoe){
int ix,i_ep,i_dl;
float ep,dl;
float if_ep,if_dl;
int nx;

nx=ker_par->nx;

if (icoe==0){
  for(ix=0;ix<nx;ix++){
    ep=ep_z[ix]; dl=dl_z[ix];
    if_ep=(ep-aniim.o_ep)/aniim.d_ep; if_dl=(dl-aniim.o_dl)/aniim.d_dl;
    i_ep=(int)(if_ep); i_dl=(int)(if_dl);
    if (if_ep-i_ep>0.5)i_ep++; if(if_dl-i_dl>0.5)i_dl++;
    if (i_ep>=aniim.n_ep || i_ep <0 ) printf("bad\n");
    if (i_dl>=aniim.n_dl || i_dl <0) printf("bad\n");
    if (aniim.nfdcoe==2){
    (ker_par->bvector)[ix]=aniim.fdcoe[i_ep][i_dl][0];
    (ker_par->avector)[ix]=aniim.fdcoe[i_ep][i_dl][1];
    (ker_par->bxvector)[ix]=aniim.fdcoe[i_ep][i_dl][0]*ker_par->bxnob;
    (ker_par->axvector)[ix]=aniim.fdcoe[i_ep][i_dl][1]*ker_par->axnoa;
    }
    else{
    }
    
  } 
}

}

void shot_ker_ani_implicit_fd(__complex__ float *wld_z,float *ca,float *cb,struct shot_ker_par_type ker_par,int signn)
{
//complex :: wld_z(:,:)
//real    :: ca(:,:),cb(:,:)

  int nx,ny,ix,iy;
  float tx,ty,ax,ay,bx,by;
  __complex__ float *ux,*vx,*uy,*vy;
  float *cax,*cbx,*cay,*cby;

  ax=-signn*ker_par.ax; ay=-signn*ker_par.ay; 
  bx=ker_par.bx; by=ker_par.by; 
  nx=ker_par.nx; ny=ker_par.ny;
  tx=ker_par.tx; ty=ker_par.ty;

  ux=ker_par.ux; vx=ker_par.vx; cax=ker_par.cax; cbx=ker_par.cbx;
  uy=ker_par.uy; vy=ker_par.vy; cay=ker_par.cay; cby=ker_par.cby;
  for(iy=0;iy<ny;iy++){
    rowc(wld_z,ux,iy,nx,1);  //ux=wld_z(iy,:)
    rowf(ca,cax,iy,nx,1);   //  cax=ca(iy,:)
    rowf(cb,cbx,iy,nx,1);   //  cbx=cb(iy,:)
    ani_implicit_fd(ux,vx,tx,cax,cbx,nx,ker_par,signn); //,rax,rbx,rcx);
    //fd(ux,vx,tx,ax,bx,cax,cbx,nx,ker_par); //,rax,rbx,rcx);
    rowc(wld_z,vx,iy,nx,0);//  wld_z(iy,:,:)=vx
  }
}

void ani_implicit_fd(__complex__ float *u,__complex__ float *v,float tr,float *ca,float *cb,int nx,struct shot_ker_par_type ker_par,int signn)
{ // u(nx),v(nx),ca(nx),cb(nx)

  __complex__ float *ra,*rb,*rc;
  __complex__ float  url,urr,ror,rol,rorr,rorl;
  float *a,*b;   // a,b is finite difference coeficient a=a*dz/(2*dx*dx)  b=b/(dx*dx)
  int  ix;
  float ax,bx;

  a=ker_par.axvector; b=ker_par.bxvector;
  ra=ker_par.ra; rb=ker_par.rb; rc=ker_par.rc;
  for(ix=0;ix<nx;ix++){
    ax=a[ix]*(-signn); bx=b[ix];
    //printf("ax=%f,bx=%f\n",ax,bx);
    if (ix==0)    url=cmplx(0.0,0.0);
    else          url=u[ix-1];
    if (ix==nx-1) urr=cmplx(0.0,0.0);
    else          urr=u[ix+1];
    ror=cmplx(tr+bx*cb[ix]*cb[ix],ax*ca[ix]);
    if (ix==nx-1) rorr=ror;
    else rorr=cmplx(tr+bx*cb[ix]*cb[ix+1],ax*ca[ix]);
    if (ix==0) rorl=ror;
    else rorl=cmplx(tr+bx*cb[ix]*cb[ix-1],ax*ca[ix]);
    v[ix]=u[ix]-2.0*ror*u[ix]+rorr*urr+rorl*url;
    

    rol=conjg(ror);
    ra[ix]=1.0-2.0*rol;
    //if (ix <nx-1) rb[ix] =rol;
    //if (ix >0) rc[ix-1]=rol;
    if (ix <nx-1) rb[ix] =cmplx(tr+bx*cb[ix]*cb[ix+1],-ax*ca[ix]);
    if (ix >0) rc[ix-1]=cmplx(tr+bx*cb[ix]*cb[ix-1],-ax*ca[ix]);
  }
  thryj(ra,rb,rc,v,nx,1);
//  free(ra); free(rb); free(rc);
}

void shot_ker_ani_implicit_li_filter(__complex__ float *wld_z,float w_v0_z,float ep0,float dl0,float a0,float b0,struct shot_ker_par_type ker_par,int signn)
{
  int nx,ny;
  float fkx,fky,dkx,dky,dz;

  int ix,iy,ipi,isin,ikz2;
  float kx,ky,kz,kz2,phsft,pio2,wpi,tphsft,wsin,sin_phsft,cos_phsft,kx2;
  float rotate,pfiltercut;

  rotate=ker_par.rotate;
  pio2=3.1415926*2.0;
  nx=ker_par.nx; ny=ker_par.ny;
  fkx=ker_par.fkx; fky=ker_par.fky;
  dkx=ker_par.dkx; dky=ker_par.dky;
  dz=ker_par.dz; 
  
  for(iy=0;iy<1;iy++){
    for(ix=0;ix<nx;ix++){  //do ix=1,nx
      kx=fkx+ix*dkx;
      kx2=(kx*kx)/(w_v0_z*w_v0_z);
      kz2=(1-kx2*(1.0+2.0*ep0))/(1.0-kx2*2.0*(ep0-dl0)); 
      //kz2=1-kx2;
      if (kz2>=0){
        if (fabs(kx/w_v0_z)>sin(3.1415926*70.0/180.0)){
          phsft=-signn*dz*w_v0_z*(sqrt(kz2)-(1-(a0*kx2)/(1-b0*kx2) ));
          //phsft=-signn*dz*w_v0_z*(+(1-(a0*kx2)/(1-b0*kx2) ));
          //phsft=-signn*dz*w_v0_z*(sqrt(kz2));
          wld_z[i2(iy,ix,nx)]=wld_z[i2(iy,ix,nx)]*cmplx(cos(phsft),sin(phsft));
        }
      }
      else{
        if (kz2<-1) kz2=-1;
        phsft=dz*w_v0_z*(sqrt(-kz2));
        //wld_z[i2(iy,ix,nx)]=wld_z[i2(iy,ix,nx)]*exp(-phsft);
        wld_z[i2(iy,ix,nx)]=0.0;
      }
    }
  }
}


void shot_ker_ani_implicit_phaseshift(__complex__ float *wld_z,float w_v0_z,float ep0,float dl0,struct shot_ker_par_type ker_par,int signn)
{
  int nx,ny;
  float fkx,fky,dkx,dky,dz;

  int ix,iy,ipi,isin,ikz2;
  float kx,ky,kz,kz2,phsft,pio2,wpi,tphsft,wsin,sin_phsft,cos_phsft,kx2;
  float rotate,pfiltercut;

  rotate=ker_par.rotate;
  pio2=3.1415926*2.0;
  nx=ker_par.nx; ny=ker_par.ny;
  fkx=ker_par.fkx; fky=ker_par.fky;
  dkx=ker_par.dkx; dky=ker_par.dky;
  dz=ker_par.dz; 
  
  for(iy=0;iy<1;iy++){
    for(ix=0;ix<nx;ix++){  //do ix=1,nx
      kx=fkx+ix*dkx;
      kx2=(kx*kx)/(w_v0_z*w_v0_z);
      kz2=(1-kx2*(1.0+2.0*ep0))/(1.0-kx2*2.0*(ep0-dl0)); 
      //kz2=1-kx2;
      if (kz2>=0){
        phsft=-signn*dz*w_v0_z*(sqrt(kz2));
        wld_z[i2(iy,ix,nx)]=wld_z[i2(iy,ix,nx)]*cmplx(cos(phsft),sin(phsft));
      }
      else{
        if (kz2<-1) kz2=-1;
        phsft=dz*w_v0_z*(sqrt(-kz2));
        //wld_z[i2(iy,ix,nx)]=wld_z[i2(iy,ix,nx)]*exp(-phsft);
        wld_z[i2(iy,ix,nx)]=0.0;
      }
    }
  }
}



void shot_ker_ani_implicit_li_filter_new(__complex__ float *wld_z,float w_v0_z,float ep0,float dl0,float a01,float b01,float a02,float b02, struct shot_ker_par_type ker_par,int signn)
{
  int nx,ny;
  float fkx,fky,dkx,dky,dz;

  int ix,iy,ipi,isin,ikz2;
  float kx,ky,kz,kz2,phsft,pio2,wpi,tphsft,wsin,sin_phsft,cos_phsft,kx2;
  float dx2,dx;
  float rotate,pfiltercut;
  __complex__ float leftterm,rightterm;
  float aterm,bterm,deltx2,tr;

  rotate=ker_par.rotate;
  pio2=3.1415926*2.0;
  nx=ker_par.nx; ny=ker_par.ny;
  fkx=ker_par.fkx; fky=ker_par.fky;
  dkx=ker_par.dkx; dky=ker_par.dky;
  dz=ker_par.dz;   dx=ker_par.dx; dx2=dx*dx;
  tr=0.11; 
 
  for(iy=0;iy<1;iy++){
    for(ix=0;ix<nx;ix++){  //do ix=1,nx
      kx=fkx+ix*dkx;
      kx2=(kx*kx)/(w_v0_z*w_v0_z);
      kz2=(1-kx2*(1.0+2.0*ep0))/(1.0-kx2*2.0*(ep0-dl0)); 
      if (kz2>=0){
        if (kx2>sin(75/180.0*3.1415926)*sin(75.0/180.0*3.1415926)){
          phsft=-signn*dz*w_v0_z*(sqrt(kz2)-1);
          wld_z[i2(iy,ix,nx)]=wld_z[i2(iy,ix,nx)]*cmplx(cos(phsft),sin(phsft));
          //phsft=-signn*dz*w_v0_z*(1);
          //wld_z[i2(iy,ix,nx)]=wld_z[i2(iy,ix,nx)]*cmplx(cos(phsft),sin(phsft));
          deltx2=2.0*(cos(kx*dx)-1.0)/dx2;
          bterm=tr*dx2+b01/(w_v0_z*w_v0_z);
          aterm=-a01*dz/(2.0*w_v0_z);
          leftterm=1.0+cmplx(bterm,-aterm)*deltx2;
          rightterm=1.0+cmplx(bterm,aterm)*deltx2; 
          wld_z[i2(iy,ix,nx)]=wld_z[i2(iy,ix,nx)]/(rightterm/leftterm);
          bterm=tr*dx2+b02/(w_v0_z*w_v0_z);
          aterm=-a02*dz/(2.0*w_v0_z);
          leftterm=1.0+cmplx(bterm,-aterm)*deltx2;
          rightterm=1.0+cmplx(bterm,aterm)*deltx2;
          wld_z[i2(iy,ix,nx)]=wld_z[i2(iy,ix,nx)]/(rightterm/leftterm);
        }
      }
      else{
        if (kz2<-1) kz2=-1;
        phsft=dz*w_v0_z*(sqrt(-kz2));
        //wld_z[i2(iy,ix,nx)]=wld_z[i2(iy,ix,nx)]*exp(-phsft);
        wld_z[i2(iy,ix,nx)]=0.0;
      }
    }
  }
}
