#include <sepcube.h>
#include <sep3dc.h>
#include <sgjbase.h>

int file_open_input(char *tag, filehead *myfilehead)
{
  int i;
  sep3d myfile;
  if(0!=init_sep3d_tag(tag,&myfile,"INPUT")) return 1;
  else{
    myfilehead->ndims=myfile.ndims;
    for (i=0;i<myfile.ndims; i++){
       myfilehead->n[i]=myfile.n[i]; 
       myfilehead->o[i]=myfile.o[i]; 
       myfilehead->d[i]=myfile.d[i];
    } 
    return 0;
  }
}

int file_open_scratch(char *tag, filehead *myfilehead)
{
  int i;
  sep3d myfile;
  if(0!=init_sep3d_tag(tag,&myfile,"SCRATCH")) return 1;
  else{
    myfilehead->ndims=myfile.ndims;
    for (i=0;i<myfile.ndims; i++){
       myfilehead->n[i]=myfile.n[i]; 
       myfilehead->o[i]=myfile.o[i]; 
       myfilehead->d[i]=myfile.d[i];
    } 
    return 0;
  }
}

int file_open_output(char *tag, filehead myfilehead)
{
  int i;
  sep3d myfile;
  
  if (0!=init_sep3d_par(&myfile,"OUTPUT","FLOAT","REGULAR",myfilehead.ndims,0)) return 1;
  for (i=0;i<myfilehead.ndims; i++){
    myfile.o[i]=myfilehead.o[i]; myfile.n[i]=myfilehead.n[i]; myfile.d[i]=myfilehead.d[i];
  }
  sep3d_set_sep3d(&myfile);
  if(0!=  sep3dc_write_description(tag,&myfile)) return 1;
  return 0;
}

int file_open_output_c(char *tag, filehead myfilehead)
{
  int i;
  sep3d myfile;
  if (0!=init_sep3d_par(&myfile,"OUTPUT","COMPLEX","REGULAR",myfilehead.ndims,0))return 1;
  for (i=0;i<myfilehead.ndims; i++){
    myfile.o[i]=myfilehead.o[i]; myfile.n[i]=myfilehead.n[i]; myfile.d[i]=myfilehead.d[i];
  }
  sep3d_set_sep3d(&myfile);
  if(0!=  sep3dc_write_description(tag,&myfile)) return 1;
  return 0;
}

int file_release(char *tag)
{
  auxclose(tag);
  return 0;
}


