#include <math.h>
#include "sgjbase.h"
__complex__ float cmplx(float realpart,float imagpart){
  __complex__ float cmplxnumber;
  __real__ cmplxnumber=realpart; __imag__ cmplxnumber=imagpart;
  return cmplxnumber;
}


float real(__complex__ float cmplxnumber)
{
   return __real__ cmplxnumber;
}

float aimag(__complex__ float cmplxnumber)
{
  return __imag__ cmplxnumber;
}


__complex__ float csqrt(__complex__ float a)
{
  float x,y,w,r,ar= __real__ a, ai=__imag__ a;
  if (ar==0.0 && ai==0.0) {
    return cmplx(0.0,0.0);
  }else {
    x = (ar>=0.0?ar:-ar);
    y = (ai>=0.0?ai:-ai);
    if (x>=y) {
       r = y/x;
    w = sqrt(x)*sqrt(0.5*(1.0+sqrt(1.0+r*r)));
    } else {
      r = x/y;
      w = sqrt(y)*sqrt(0.5*(r+sqrt(1.0+r*r)));
    }
    if (ar>=0.0) {
      return cmplx(w,ai/(2.0*w));
    } else {
      if (ai<0.0) w = -w;
        return cmplx(ai/(2.0*w),w);
    }
  }
 
}


__complex__ float cpow(__complex__ float a, int p){
  __complex__ float b,res=cmplx(1.0,0.0);
  if (p==0) {
    return cmplx(1.0,0.0);
  } else if (__real__ a==0.0 && __imag__ a==0.0) {
    return cmplx(0.0,0.0);
  } else {
    res=cmplx(1.0,0.0);
    b=a;
    if (p<0) {
      p = -p;
      b = 1.0/b;
    }
    for(;;) {
      if (p&1) res *= b;
      if ((p>>=1)==0)
        return res;
      else
        b *= b;
    }
  }
}

__complex__ float cpowf(__complex__ float a, float p){
  float ar,ai,amp,phs;
  if (p==0.0) return cmplx(1.0,0.0);
  if (__real__ a==0.0 && __imag__ a==0.0) return cmplx(0.0,0.0);
  ar = __real__ a; ai = __imag__ a;
  amp = exp(0.5*p*log(ar*ar+ai*ai));
  phs = p*atan2(ai,ar);
  return cmplx(amp*cos(phs),amp*sin(phs));
}

__complex__ float conjg(__complex__ float x){
  return ~x;
}
