#ifndef MAX
#define	MAX(x,y) ((x) > (y) ? (x) : (y))
#endif
#ifndef MIN
#define	MIN(x,y) ((x) < (y) ? (x) : (y))
#endif
#ifndef SGN
#define SGN(x) ((x) < 0 ? -1.0 : 1.0)
#endif
#ifndef PI 
#define PI 3.1415926
#endif

// begin arrayindex -----------------------------------
int i3(int, int, int, int*);
int i2(int i, int j, int n1);
int i3(int i, int j, int k, int *n);
int i4(int i, int j, int k, int l, int *n);
int i5(int i, int j, int k, int l, int m, int *n);
int i6(int i, int j, int k, int l, int m, int p, int *n);

void d3( int n2,int n3,int *n);
void d4(int n2,int n3,int n4,int *n);
void d5(int n2,int n3,int n4,int n5,int *n);
void d6(int n2,int n3,int n4,int n5,int n6, int *n);

int * allocatei(int n);
float * allocatef(int n);
__complex__ float * allocatec(int n);

void rowf( float *a,float *rowofa,int iy, int nx,int );
void rowc(__complex__ float *a,__complex__ float *rowofa,int iy, int nx,int);
void rowi( int *a,int *rowofa,int iy, int nx,int);
void colc(__complex__ float *a,__complex__ float *rowofa,int ix, int nx,int ny,int forward);
float maxval( float *a, int nx);
float maxvalc(__complex__ float *a,int nx);
float minval( float *a,int nx);
void matrix_equ_c(__complex__ float *a,__complex__ float *b,int ny,int nx);
void vector_value_f(float *a, float value,int nx);
void vector_value_c(__complex__ float *a,__complex__ float value,int nx);
void vector_cp_c(__complex__ float *a, __complex__ float *b, int nx);
void vector_cp_f(float *a, float *b, int nx);
// end arrayindex-------------------------------------------------------------





// begin mycomplex mycomplex-------------------------------

float real(__complex__ float cmplxnumber);
__complex__ float cmplx(float realpart,float imagpart);
float aimag(__complex__ float cmplxnumber);
__complex__ float csqrt(__complex__ float a);
__complex__ float cpow(__complex__ float a, int p);
__complex__ float cpowf(__complex__ float a, float p);
__complex__ float conjg(__complex__ float x);

// end my complex


// begin mymath
void thryj(__complex__ float* a, __complex__ float* b, __complex__ float* c, __complex__ float* v, int h, int yJ);
void thrnew(__complex__ float *a, __complex__ float *b,__complex__ float *c, __complex__ float *v, int n);
void p3solver(float* a, __complex__ float* x);
void p4solver(float *a, __complex__ float* z);
void qrdcmp(float* a,int m,int n,float* d,int sing);
void qrdpost(float* a,int m,int n,float* d,float* q,float* r);
void qrcon(float* q,float* r,__complex__ float* dpp,__complex__ float* conap,int m,int n);
void uptrisolver(float* r,__complex__ float* conap,int n);
__complex__ float chooseproot(__complex__ float *allroot);
void stoepd (int n, double r[], double g[], double f[], double a[]);
// end mymath

//begin sgjio
#define maxNdims 10
struct _filehead{
  int ndims;
  int n[maxNdims];
  float o[maxNdims];
  float d[maxNdims];
};
typedef struct _filehead filehead;

int file_open_input(char *tag, filehead *myfilehead);
int file_open_output(char *tag, filehead myfilehead);
int file_open_output_c(char *tag, filehead myfilehead);
int file_open_scratch(char *tag, filehead *myfilehead);
int file_release(char *tag);
//end sgjio

//begin fft
int npfao (int nmin, int nmax);
void pfacc(int isign, int n, __complex__ float cz[]);
void  cwpfft1d(__complex__ float *a,int n,int inv);
int fftn(int nmin);
//end fft

//begin sinc
void sinc_mksinc (float d, int lsinc, float sinc[]);
double dsinc (double x);
//end sinc


//new allocate and free
int *allocate_i1(int n1);
void free_i1(int *p);
int **allocate_i2(int n1, int n2);
void free_i2(int **p);
int ***allocate_i3(int n1, int n2, int n3);
void free_i3(int ***p);
float *allocate_f1(int n1);
void free_f1(float *p);
float **allocate_f2(int n1, int n2);
void free_f2(float **p);
float ***allocate_f3(int n1, int n2, int n3);
void free_f3(float ***p);
float ****allocate_f4(int n1, int n2, int n3, int n4);
void free_f4(float ****p);
float *****allocate_f5(int n1, int n2, int n3, int n4, int n5);
void free_f5(float *****p);
float ******allocate_f6(int n1, int n2, int n3, int n4, int n5, int n6);
void free_f6(float ******p);
__complex__ float *allocate_c1(int n1);
void free_c1(__complex__ float *p);
__complex__ float **allocate_c2(int n1, int n2);
void free_c2(__complex__ float **p);
__complex__ float ***allocate_c3(int n1, int n2, int n3);
void free_c3(__complex__ float ***p);
__complex__ float ****allocate_c4(int n1, int n2, int n3, int n4);
void free_c4(__complex__ float ****p);
__complex__ float *****allocate_c5(int n1, int n2, int n3, int n4, int n5);
void free_c5(__complex__ float *****p);
__complex__ float ******allocate_c6(int n1, int n2, int n3, int n4, int n5, int n6);
void free_c6(__complex__ float ******p);
float **allocate_f1_pointer(int n2);
__complex__ float **allocate_c1_pointer(int n2);
float ****allocate_f1_pointer3(int n4);
//end new allocate and free
