// begin ani (ani.c)
void coe(float* a,float phi,float ep,float dl,float w_vp,float f,float kx);
void coe3d(float *a, float phi,float ep,float dl,float w_vp,float f, float kx,float ky);
__complex__ float kzani(float phi,float ep,float dl,float w_vp,float f,float kx);
__complex__ float kzani3d(float phi,float ep,float dl,float w_vp,float f,float kx,float ky);
__complex__ float dkz(float phi,float ep,float dl,float w_vp,float f,float kx);
__complex__ float dkz3d(float phi,float ep,float dl,float w_vp,float f,float kx,float ky);
__complex__ float dphase(float phi,float ep,float dl,float w_vp,float f,float kx,float dz);
__complex__ float dphase3d(float phi,float ep,float dl,float w_vp,float f,float kx,float ky,float dz);
void dph(float phi,float ep,float dl,float w_vp,float f,float dkx,float dz,int m,__complex__ float *dpp,int weitm);
void dph3d(float phi,float ep,float dl,float w_vp,float f,float dkx,float dky,float dz,int mx,int my,__complex__ float *dpp,float *weit);
int weit(float phi,float ep,float dl,float w_vp,float f,float dkx,int m);
void weit3d(float *weight,float phi,float ep,float dl,float w_vp,float f,float dkx,float dky,int mx,int my);
void phase_apro_matrix_cos(float *a,float dx,float dkx,int m,int n);
void phase_apro_matrix_cos3d(float *a,float dx,float dy,float dkx,float dky,int mx,int my,int nx,int ny);
void phase_apro_matrix_sin(float *a,float dx,float dkx,int m,int n);
void phase_apro_matrix_sin3d(float *a,float dx,float dy,float dkx,float dky,int mx,int my,int nx,int ny);
void convlv_coe(int m,int n,__complex__ float *conap,__complex__ float *conam,__complex__ float *dpc,__complex__ float *dps, float *qc,float *rc,float *qs,float *rs);
void convlv_coe3d(int mx,int my,int nx,int ny,__complex__ float *conap,__complex__ float *conam,__complex__ float *dpc,__complex__ float *dps, float *qc,float *rc,float *qs,float *rs);
void ani_equation_con(float dx,float dkx,int m,int n,int weitm,float *qc,float *rc,float *qs,float *rs);
void ani_equation_con3d(float dx,float dy,float dkx,float dky,int mx,int my,int nx,int ny,float *weight,float *qc,float *rc,float *qs,float *rs);
void ani_init(float dx,float dkx,int m,int n,int nweit,int *weitm,float *qc_table, float *rc_table, float *qs_table,float *rs_table);
int weitmlist(int *weitm,float phi,float dkx,float f,int m,
             float o_ep,float d_ep,int n_ep,float o_dl,float d_dl,int n_dl,float o_w_vp,float d_w_vp,int n_w_vp);
void explicit_table(__complex__ float *contablepp,__complex__ float *contablepm,
                    float phi,float f,float dx,float dkx,float dz, int m,int n,
                    float o_ep,float d_ep,int n_ep,float o_dl,float d_dl,int n_dl,float o_w_vp,float d_w_vp,int n_w_vp);
//void explicit_table3d(__complex__ float *conapp,__complex__ float *conapm,
//                      float phi,float f,float dx,float dy,float dkx,float dky,float dz,int mx,int my,int nx,int ny,
//                      float ep,float dl,float w_vp);
void explicit_table3d(__complex__ float *conapp,__complex__ float *conapm,
                      float phi,float f,float dx,float dy,float dkx,float dky,float dz,int mx,int my,int nx,int ny,
                      float ep,float dl,float w_vp,float *weight,float *qc,float *rc,float *qs,float *rs);
float kycoe3d(float phi,float ep,float dl,float w_vp,float f, float kx,float kz);

void kzvti(__complex__ float *sz,float dsx,float ep,float dl,int nsx);
void implicitleftmatrixisovtifd2(float **leftmatrix, __complex__ float * sz,int nsx,float dsx);
void implicitleftmatrixisovtifd1(float **leftmatrix, __complex__ float * sz,int nsx,float dsx);
void qrsolver(float **leftmatrix,__complex__ float *kz,__complex__ float *conap,int m,int n);
void imfd2coesolver(float ep,float dl,int nsxall, float *alpha1,float *alpha2,float *beta1,float *beta2);
void imfd1coesolver(float ep,float dl,int nsxall, float *alpha1,float *beta1);


// end ani (ani.c)


// begin kernal(kernal.c)
struct shot_ker_par_type
{
  int op,nx,ny,nref;
  float dx,dy,dz,fkx,dkx,fky,dky;
  float ax,ay,bx,by,axnoa,aynoa,bxnob,bynob,tx,ty,fda,fdb;
  int is2d;
  __complex__ float *ux,*vx,*uy,*vy,*ra,*rb,*rc;
  float *cax,*cbx,*cay,*cby;
  float *axvector,*bxvector,*avector,*bvector;
  __complex__ float *tmp_fft, *add_wld,*tmp_wld;
  float *v0_z,*v_zw,*v_zw0;
  float *sin,*cos,*sqrt;
  float dsin,dqrt;
  int Nsin;
  float rotate;
};
struct shot_ker_ani_type
{
  float phi,f;
  float o_ep,d_ep,o_dl,d_dl,o_w_vp,d_w_vp;
  int m,n,n_ep,n_dl,n_w_vp;
  __complex__ float *contablepp,*contablepm,*conapp,*conapm;
};

struct shot_ker_ani_implicit_type
{
  float o_ep,d_ep,o_dl,d_dl;
  int n_ep,n_dl;
  float ***fdcoe;
  int nfdcoe;
};

void li_filter(__complex__ float *wld_z,float w_v0_z,struct shot_ker_par_type ker_par,int signn);
void li_filter_new(__complex__ float *wld_z,float w_v0_z,struct shot_ker_par_type ker_par,int signn);
void shot_phase_shift(__complex__ float *wld_z,float w_v0_z,struct shot_ker_par_type ker_par,int signn);
void shot_ker_ssf(__complex__ float *wld_z,float w_v0_z,float w,float *v_z, struct shot_ker_par_type ker_par,int signn);
void shot_ker_fd(__complex__ float *wld_z,float *ca,float *cb,struct shot_ker_par_type ker_par,int signn);
void fd(__complex__ float *u,__complex__ float *v,float tr,float a,float b,float *ca,float *cb,int nx,struct shot_ker_par_type);
void shot_ker_depth_onestep(__complex__ float *wld_z,float *v_z,float w,int signn, struct shot_ker_par_type ker_par);
struct shot_ker_par_type shot_ker_p_init(int op,int nx,int ny,float dx,float dy,float dz,float a,float b,float trick,int is2d,float rotate);
void shot_ker_release(struct shot_ker_par_type *ker_par);
void shot_ker_depth_onestep_ani_phaseshift(__complex__ float *wld_z,float *v_z,float w,float ep,float dl,float phi, float f,int signn, struct shot_ker_par_type ker_par);
void shot_ker_depth_onestep_vti_phaseshift(__complex__ float *wld_z,float w_v0_z,float ep,float dl,int signn, struct shot_ker_par_type ker_par);
void shot_ker_depth_onestep_impulse(__complex__ float *wld_z,float *v_z,float w,int signn, float ep,float dl,struct shot_ker_par_type ker_par);
void shot_ker_depth_onestep_fd2(__complex__ float *wld_z,float *v_z,float w,int signn, float a1,float b1,float a2,float b2,struct shot_ker_par_type ker_par);
void li_filter_fd2(__complex__ float *wld_z,float w_v0_z,float a1,float b1,float a2,float b2,struct shot_ker_par_type ker_par,int signn);

//end kernal(kernal.c)
// anikernal
struct shot_ker_ani_type shot_ker_ani_init_impulse(float phi,int nx,float dx,float dy,float dz);
struct shot_ker_ani_type shot_ker_ani_init(float *phi,int nx,float dx,float dy,float dz);
void  get_convlv_coe(float w_vp,float ep,float dl,struct shot_ker_ani_type *ani_par);
void shot_ani_convlv(__complex__ float *wld_z,float *v_z,float *ep_z,float *dl_z,float w,struct shot_ker_par_type ker_par,struct shot_ker_ani_type ani_par,int signn);
void shot_ani_convlv3dtest(__complex__ float *wld_z,__complex__ float *conapp,__complex__ float *conapm,int tnx,int tny,struct shot_ker_par_type ker_par, int signn);
void shot_ker_ani_release(struct shot_ker_ani_type *ani_par);
void shot_phase_shift_ani(__complex__ float *wld_z,float w_v0_z,float ep,float dl,float phi,float f,struct shot_ker_par_type ker_par,int signn);
void shot_phase_shift_vti(__complex__ float *wld_z,float w_v0_z,float ep,float dl,struct shot_ker_par_type ker_par,int signn);
//void inadd(__complex__ float *app,__complex__ float *p,float scale,int n);

// anikernal


// begin ani_implicit
struct shot_ker_ani_implicit_type shot_ker_ani_implicit_init(int nfdcoe);
void shot_ker_ani_implicit_release(struct shot_ker_ani_implicit_type *aniim);
void shot_ker_ani_implicit_depth_onestep(__complex__ float *wld_z,float *v_z,float *ep_z,float *dl_z,float w,int signn, struct shot_ker_par_type ker_par, struct shot_ker_ani_implicit_type aniim);
void shot_ker_ani_implicit_getab(float ep0,float dl0,float *a1,float *b1,float *a2,float *b2,struct shot_ker_ani_implicit_type aniim);
void shot_ker_ani_implicit_genaxbx(float *ep_z,float *dl_z,struct shot_ker_par_type *ker_par,struct shot_ker_ani_implicit_type aniim,int icoe);
void shot_ker_ani_implicit_fd(__complex__ float *wld_z,float *ca,float *cb,struct shot_ker_par_type ker_par,int signn);
void ani_implicit_fd(__complex__ float *u,__complex__ float *v,float tr,float *ca,float *cb,int nx,struct shot_ker_par_type ker_par,int signn);
void shot_ker_ani_implicit_li_filter(__complex__ float *wld_z,float w_v0_z,float ep0,float dl0,float a0,float b0,struct shot_ker_par_type ker_par,int signn);
void shot_ker_ani_implicit_li_filter_new(__complex__ float *wld_z,float w_v0_z,float ep0,float dl0,float a01,float b01,float a02,float b02, struct shot_ker_par_type ker_par,int signn);
void shot_ker_ani_implicit_phaseshift(__complex__ float *wld_z,float w_v0_z,float ep0,float dl0,struct shot_ker_par_type ker_par,int signn);

// end_ani_implicit


//begin data
struct shot_data_par_type
{
  float dhx,dhy,dw,dsx,dsy;
  float ohx,ohy,ow,osx,osy;
  int nhx,nhy,nw,nsx,nsy;
  __complex__ float *wavelet;
  __complex__ float *tmp_wld;
};
// begin plane
struct shot_plane_par_type
{
   float ow,dw,ox,oy,dx,dy,opx,dpx,opy,dpy;
   int   npx,npy,nx,ny,nw;

   float osx,osy,dsx,dsy;
   int   nsx,nsy;
   float ohx,ohy,dhx,dhy;
   int   nhx,nhy;
};
// end plane
struct shot_data_par_type shot_data_init();
void shot_data_release(struct shot_data_par_type *data_par);
void shot_data_wavelet(struct shot_data_par_type data_par);
void shot_data_grab_mig_par(int i_sx,int i_sy,float *mig_x_min,float *mig_y_min, int *nx,int *ny,struct shot_data_par_type data_par );
void data_source(float min_x,float min_y,int nx,int ny,int iw,int i_sx,int i_sy,__complex__ float *wld,struct shot_data_par_type data_par);
void data_receiver(float min_x,float min_y,int nx,int ny,int iw,int i_sx,int i_sy,__complex__ float *wld,struct shot_data_par_type data_par);
void shot_data_plane_grab_mig_par(int i_sx,int i_sy,float *mig_x_min,float *mig_y_min,int *nx,int *ny,struct shot_data_par_type data_par,struct shot_plane_par_type *plane_par );
void shot_plane_source(float min_x,float min_y,int nx,int ny,int iw,int i_px,int i_py,__complex__ float *wld,struct shot_data_par_type data_par,struct shot_plane_par_type plane_par);
void shot_plane_source_3d(float min_x,float min_y,int nx,int ny,int iw,int i_px,int i_py,__complex__ float *wld,struct shot_data_par_type data_par,struct shot_plane_par_type plane_par);
void shot_plane_receiver(float min_x,float min_y,int nx,int ny,int iw,int i_sx,int i_sy,__complex__ float *wld,struct shot_data_par_type data_par,struct shot_plane_par_type plane_par);
__complex__ float * shot_data_wavelet_read(filehead *wavlt);
void shot_data_source_modeling(float sx,float min_x,int nx,__complex__ float *wld,__complex__ float *wavelet, int iw, float dhx);
//end data

//begin rotate
struct shot_rotate_par_type
{
  float rotate_angle; 
  int ix_rotate_center;
  int nx,nz,nx_rotate,nz_rotate,ny_rotate,nz_left,nz_right;
  int nz_s_rotate;
  float dx,dz;
  __complex__ float *wld_before_rotate, *wld_after_rotate;
  float *sinc;
  int Nsinc;
  // add in 3d
  float dy,oyout_azimuth,oxout_tilt,azimuth;
  int ny,nyout_azimuth,nxout_azimuth,nxout_tilt,nzout_tilt;
  float sinazimuth,cosazimuth,sintilt,costilt;
  float ox,oy;
  int nx_s_rotate;
  int *bx_s_rotate;  
  // end add in 3d
};
struct shot_rotate_par_type shot_rotate_init(float rotate_angle,int nx,int nz,float dx, float dz);
struct shot_rotate_par_type shot_rotate_init_3d(float rotate_angle, float azimuth,int nx,int ny,int nz,float dx,float dy, float dz,float ox,float oy);
void shot_rotate_release(struct shot_rotate_par_type *rotate_par);
void shot_rotate_release_3d(struct shot_rotate_par_type *rotate_par);
void shot_rotate_data_rotate(__complex__ float * z0_s,__complex__ float * z0_s_rotate,struct shot_rotate_par_type *rotate_par);
void shot_rotate_image_rotate(float *image,float *image_rotate,struct shot_rotate_par_type rotate_par);
void shot_rotate_get_bx_ex_iz(float *dkx,int *bx,int *ex, int iz,int boundary_nx, struct shot_rotate_par_type rotate_par);
void shot_rotate_get_bx_ex_iz_3d(float *dkx,int *bx,int *ex, int iz,int boundary_nx, struct shot_rotate_par_type rotate_par);

void shot_rotate_velocity_rotate_azimuth(filehead velocity,char *tagin,char *tagout,struct shot_rotate_par_type rotate_par);
void shot_rotate_data_rotate_azimuth(__complex__ float **wldin,__complex__ float **wldout,struct shot_rotate_par_type rotate_par);
void shot_rotate_data_tilt_2d(__complex__ float *wldin, __complex__ float **wldout,struct shot_rotate_par_type rotate_par);
void shot_rotate_data_tilt_3d(__complex__ float **wldin,__complex__ float ***wldout,struct shot_rotate_par_type rotate_par);
void shot_rotate_velocity_tilt_2d(float **velin2d,float **velout2d,filehead velocityin,struct shot_rotate_par_type rotate_par);
void shot_rotate_velocity_tilt_3d(char *tagin,char *tagout,struct shot_rotate_par_type rotate_par,int ny_block);
void shot_rotate_velocity_tiltonly_3d(char *tagin,char *tagout,struct shot_rotate_par_type rotate_par,int ny_block,filehead velocityin);
void shot_rotate_data_tiltonly_3d(__complex__ float **wldin,__complex__ float ***wldout,struct shot_rotate_par_type rotate_par);
void shot_rotate_image_tilt_2d(float **image,float **image_rotate,struct shot_rotate_par_type rotate_par);
//end rotate



// begin velocity
void velocity_init(filehead *velocity);
void velocity_ani_init(filehead *eps, filehead *dlt);
void velocity_read(filehead velocity,float *vel,filehead wave,float theta,int ix_center,char *tag);
void velocity_read3d(float *vel,int mig_size,char *tag);
void velocity_minmax(char *tag,filehead velocity,float *minvel,float *maxvel);
// end velocity

//begin image
struct shot_image_par_type
{
  float min_x,max_x,min_y,max_y;
  float dx,dy,dz;
  float ohx,ohy;
  int nx,ny,nz,nhx,nhy;
  float *sincx_table; 
};
struct shot_image_par_type shot_image_grab_par();
void shot_image_init(float dx,float dy,float dz,int nz,struct shot_image_par_type *image_par);
void shot_image_init_3d(float dx,float dy,float dz,int nz,struct shot_image_par_type *image_par,int nx,int ny,float ox);
void shot_image_init_3d_rotate(struct shot_rotate_par_type rotate_par,struct shot_image_par_type *image_par);
void shot_image_cross(__complex__ float *wld_s,__complex__ float *wld_r,float *image_z,int nx,int ny,struct shot_image_par_type image_par);
void shot_image_cross_tilt(__complex__ float *wld_s,__complex__ float *wld_r,float *image_z,int nx,int ny,struct shot_image_par_type image_par,int nx_iz);
void shot_image_cross_tilt_3d(__complex__ float *wld_s,__complex__ float *wld_r,float ****image_z,int nx,int ny,struct shot_image_par_type image_par,int nx_iz);
void shot_image_stack(float *img,float mig_min_x,float mig_min_y,int mig_nx,int mig_ny,char *tag,struct shot_image_par_type image_par);
void shot_image_plane3d_stack(float *img,int mig_nx,int mig_ny,int icell_z,int nz_cell,int nz,char *tag,struct shot_image_par_type image_par,int readimage);
void shot_image_sinc_table(struct shot_image_par_type *image_par);
void shot_image_decompose(float *image_hx,float *image_hz,int nx,int nz,float rotate_angle,struct shot_image_par_type image_par);
void shot_image_decompose_1imagepoint(float *image_hx,float *image_hz,int nx,int nz,float rotate_angle,struct shot_image_par_type image_par);
void shot_image_release(struct shot_image_par_type *image_par);
void shot_image_reopen_3d();
//end image

