#include "sgjbase.h"
#include "sgjmig.h"
void cmptoplane_grab_par(float *opx,float *dpx, int *npx, float *opy,float *dpy,int *npy);
void shottoplane1p(__complex__ float **wld,float ox,float dx,int nx,float px,filehead shotin);
int main(int argc, char **argv)
{
   filehead shotin,planeout;
   __complex__ float **wld;
   float ow,dw,ohx,dhx,osx,dsx,plane_osx,plane_dsx,plane_osy,plane_dsy,ox,dx,esx,ehx,ex,opx,dpx,opy,dpy,px,dt;
   int nw,nhx,nsx,plane_nsx,plane_nsy,nx,npx,npy,ipx,stat,nt_pad,nt,iw_min,iw_max;
   initpar(argc,argv);

   cmptoplane_grab_par(&opx,&dpx,&npx,&opy,&dpy,&npy);
   file_open_input("Shot",&shotin);
   ow=shotin.o[0];    dw=shotin.d[0]; nw=shotin.n[0];
   ohx=shotin.o[1];   dhx=shotin.d[1]; nhx=shotin.n[1];
   osx=shotin.o[2];   dsx=shotin.d[2]; nsx=shotin.n[2];

   plane_osx=osx;   plane_dsx=dsx;   plane_nsx=nsx;
   plane_osy=0.0;   plane_dsy=12.5;  plane_nsy=1;
   ox=osx+ohx; if (ox >= osx) ox=osx-dhx; 
   if (0==getch("dx","f",&dx)) dx=dhx; 
   esx=osx+(nsx-1)*dsx; ehx=ohx+(nhx-1)*dhx; ex=esx+ehx; nx=(ex-ox)/dx+1;

   planeout.ndims=5;
   planeout.o[0]=ox;    planeout.d[0]=dx;     planeout.n[0]=nx;
   planeout.o[1]=0.0;   planeout.d[1]=dx;     planeout.n[1]=1; 
   planeout.o[2]=ow;    planeout.d[2]=dw;     planeout.n[2]=nw;
   planeout.o[3]=opx;   planeout.d[3]=dpx;    planeout.n[3]=npx;
   planeout.o[4]=opy;   planeout.d[4]=dpy;    planeout.n[4]=npy;
   file_open_output_c("Plane",planeout);
   stat=auxputch ("plane_os_x","f",&plane_osx,"Plane");
   stat=auxputch ("plane_ds_x","f",&plane_dsx,"Plane");
   stat=auxputch ("plane_ns_x","d",&plane_nsx,"Plane");
   stat=auxputch ("plane_os_y","f",&plane_osy,"Plane");
   stat=auxputch ("plane_ds_y","f",&plane_dsy,"Plane");
   stat=auxputch ("plane_ns_y","d",&plane_nsy,"Plane");  
   stat=auxpar("nt_pad","d", &nt_pad,"Shot");
   stat=auxpar("nt","d",&nt,"Shot");
   stat=auxpar("dt","f",&dt,"Shot");
   stat=auxpar("iw_min","d",&iw_min,"Shot");
   stat=auxpar("iw_max","d",&iw_max,"Shot");

   stat=auxputch("nt_pad","d", &nt_pad,"Plane");
   stat=auxputch("nt","d",&nt,"Plane");
   stat=auxputch("dt","f",&dt,"Plane");
   stat=auxputch("iw_min","d",&iw_min,"Plane");
   stat=auxputch("iw_max","d",&iw_max,"Plane");

   wld=allocate_c2(nw,nx);


   for(ipx=0;ipx<npx;ipx++){
     px=ipx*dpx+opx;
     vector_value_c(*wld,cmplx(0.0,0.0),nw*nx);
     shottoplane1p(wld,ox,dx,nx,px,shotin);
     if (srite("Plane",*wld,nx*nw*8)!=nx*nw*8) seperr("err write plane\n");
   }
 
   free_c2(wld);

   return 0;
}


void shottoplane1p(__complex__ float **wld,float ox,float dx,int nx,float px,filehead shotin){
   __complex__ float **shot;
   int nw,nhx,nsx,plane_nsx,plane_nsy,iw,ihx,ix,isx;
   float ow,dw,ohx,dhx,osx,dsx,plane_osx,plane_dsx,plane_osy,plane_dsy;
   float xdt,tx,w,hx,rx,sx;

   ow=shotin.o[0];    dw=shotin.d[0]; nw=shotin.n[0];
   ohx=shotin.o[1];   dhx=shotin.d[1]; nhx=shotin.n[1];
   osx=shotin.o[2];   dsx=shotin.d[2]; nsx=shotin.n[2];

   plane_osx=osx;   plane_dsx=dsx;   plane_nsx=nsx;
   plane_osy=0.0;   plane_dsy=12.5;  plane_nsy=1;

   shot=allocate_c2(nhx,nw);

   xdt=plane_dsx*px;
   if (sseek_block("Shot",0,nhx*nw,0) !=0) seperr("data seek wrong\n");
   for (isx=0;isx<nsx;isx++){
     sx=isx*dsx+osx;
     tx=isx*xdt;
     if ( sreed("Shot",*shot,nhx*nw*8)!=nhx*nw*8) seperr("err read\n");
     for (iw=0;iw<nw;iw++){
       w=iw*dw+ow;
       for(ihx=0;ihx<nhx;ihx++){
         hx=ihx*dhx+ohx;
         rx=sx+hx;
         ix=(rx-ox)/dx;
         if (ix >=0 || ix<nx){
           wld[iw][ix]+=shot[ihx][iw]*cmplx(cos(w*tx),sin(w*tx));
         }
       }
     }
   }
   free_c2(shot);
   
}



void cmptoplane_grab_par(float *opx,float *dpx, int *npx, float *opy,float *dpy,int *npy){
  if(0==getch("opx","f",opx)) *opx=0.0;
  if(0==getch("dpx","f",dpx)) *dpx=1.0;
  if(0==getch("npx","d",npx)) *npx=1.0;
  if(0==getch("opy","f",opy)) *opy=0.0;
  if(0==getch("dpy","f",dpy)) *dpy=1.0;
  if(0==getch("npy","d",npy)) *npy=1.0;
}
