#include "sgjbase.h"
#include "sgjmig.h"

int main(int argc, char **argv)
{
  filehead filein,fileout;
  __complex__ float *datatrace,*datawrite;
  float *dataread;
  float f_min,f_max,pi,dt,ot,dw,fw;
  int   stat,nt,nt_pad,iw_min,iw_max,nw,ndims,i,j,ntrace,iw;
  float w,tdelay;

  initpar(argc,argv);
  if (0==getch("f_min","f",&f_min) ) f_min=5.0;
  if (0==getch("f_max","f",&f_max) ) f_max=30.0;
  
  pi=3.1415926;
  stat=file_open_input("Time",&filein);
  fileout=filein;
  dt=filein.d[0]; nt=filein.n[0]; ot=filein.o[0];
  if (0==getch("nt_pad","d",&nt_pad) ) nt_pad=nt+nt/5;
  nt_pad=fftn(nt_pad);
  datatrace=allocatec(nt_pad); dataread=allocatef(nt);
  dw=2.0*pi/(nt_pad*dt);
  fw=2.0*pi*f_min; 
  iw_min=2.0*pi*f_min/dw; iw_max=2.0*pi*f_max/dw;
  nw=iw_max-iw_min+1; 
  datawrite=datatrace+iw_min;
  fileout.d[0]=dw; fileout.o[0]=fw; fileout.n[0]=nw;
  if (0==auxpar("tdelay","f",&tdelay,"Time")) tdelay=0.0;
  printf("tdelay=%f\n",tdelay);
  stat=file_open_output_c("Freq",fileout);
  stat=auxputch ("nt_pad","d",&nt_pad,"Freq");
  stat=auxputch ("nt",    "d",&nt,    "Freq");
  stat=auxputch ("dt",    "f",&dt    ,"Freq");
  stat=auxputch ("iw_min","d",&iw_min,"Freq");
  stat=auxputch ("iw_max","d",&iw_max,"Freq");

  ndims=filein.ndims;
  ntrace=1;
  for (i=1;i<=ndims-1;i++) ntrace =ntrace*filein.n[i];
  for (i=0;i<ntrace;i++){
    if (sreed("Time",dataread,4*nt)!=4*nt) seperr("err read data\n");
    for (j=0;j<nt;j++) datatrace[j]=cmplx(dataread[j],0.0);
    for (j=nt;j<nt_pad;j++) datatrace[j]=cmplx(0.0,0.0);
    pfacc(1,nt_pad,datatrace);
    if (tdelay!=0.0){
      for(iw=0;iw<nw;iw++){
        w=fw+iw*dw;
        datawrite[iw]=datawrite[iw]*cmplx(cos(-w*tdelay),sin(-w*tdelay));
      }
    }
    if (srite("Freq",datawrite,8*nw)!=8*nw) seperr("err rite data\n");
  }  
  free(datatrace); free(dataread);
  return 0;
}
