program InitVelBuild 

  use sep

  implicit none

  integer                                :: n1, n2, n3
  real                                   :: o1, o2, o3, d1, d2, d3
  integer                                :: i, j, k
  real,allocatable                       :: vel(:,:,:),initvel(:,:,:)
  real,allocatable                       :: z_seabed(:,:) 
  real                                   :: f1, f2, vmax, vmin, vwater, minv_sed, beta, vmin_eta
  real                                   :: nbr

  call initpar()
  call from_history("n1", n1)
  call from_history("n2", n2)
  call from_history("n3", n3)
  call from_history("o1", o1)
  call from_history("o2", o2)
  call from_history("o3", o3)
  call from_history("d1", d1)
  call from_history("d2", d2)
  call from_history("d3", d3)
  call from_param("vmax", vmax, 3000.)          ! .. max sediment velocity
  call from_param("vwater", vwater, 1524.)      ! .. water velocity
  call from_param("minv_sed", minv_sed, 1600.)  ! .. min sediment velocity


  allocate(vel(n1,n2,n3),initvel(n1,n2,n3))
  allocate(z_seabed(n1,n2))
  write(0,*) n1, n2, n3

  call sep_read(vel)

  nbr=1.
  initvel=nbr

  ! mask for velocity down to the sea bottom
  where(vel==vwater)
    initvel=vwater
  end where

  do j=1,n2
  do i=1,n1
      do k=1,n3-1
      if(initvel(i,j,k)==vwater .and. initvel(i,j,k+1)==nbr) then 
        z_seabed(i,j) = k+1
        exit
      end if
      end do
      do k = z_seabed(i,j),n3
        initvel(i,j,k) = (vmax-minv_sed)/(n3-z_seabed(i,j)+1)*(k-z_seabed(i,j)+1) + minv_sed
      end do
  end do
  end do


  call sep_write(initvel)

  call to_history("n1", n1)
  call to_history("n2", n2)
  call to_history("n3", n3)
  call to_history("d1", d1)
  call to_history("d2", d2)
  call to_history("d3", d3)
  call to_history("o1", o1)
  call to_history("o2", o2)
  call to_history("o3", o3)
  call to_history("esize", 4)

  deallocate(vel,initvel)

end program  
