module base_hlxcon_mod
  use  base_hlxtyp_mod
  implicit none

  type(helix), private :: aa
  real       , private :: a0
contains

  integer function base_hlxcon_init(aa_in, a0_in) result(stat)
    type(helix) :: aa_in
    real        :: a0_in
    aa = aa_in
    a0 = a0_in
    stat = 0
  end function

  integer function base_hlxcon_clos() result(stat)
    stat = 0
  end function

  integer function base_hlxcon_oper(adj, add, xx, yy) result(stat)
    logical            :: adj, add 
    real, dimension(:) :: xx, yy

    integer            :: ix, iy, ia
    if (.not.add) then
       if (adj) then
          xx = 0.
       else
          yy = 0.
       end if 
    end if

    if (adj) then
       xx = xx + a0*yy
    else 
       yy = yy + a0*xx
    end if

    do ia=1, size(aa%lag)
       do iy=1+aa%lag(ia), size(yy)
          if (associated(aa%mis)) then
             if (aa%mis(iy)) cycle
          end if
          ix = iy-aa%lag(ia)
          if (adj) then
             xx(ix) = xx(ix) + yy(iy)*aa%flt(ia)*a0
          else
             yy(iy) = yy(iy) + xx(ix)*aa%flt(ia)*a0
          end if
       end do
    end do
    stat = 0
  end function

end module
