module base_lapc3d_mod
  use  base_grad3d_mod
  implicit none

  integer                           , private :: n1, n2, n3
  real   , dimension(:,:,:,:), allocatable, private :: temp
  logical, parameter                , private :: T = .true.
  logical, parameter                , private :: F = .false.
contains

  integer function base_lapc3d_init(n1_in, n2_in, n3_in) result(stat)
    integer :: n1_in, n2_in, n3_in
    n1 = n1_in
    n2 = n2_in
    n3 = n3_in
    if (.not.allocated(temp)) allocate(temp(n1,n2,n3,3))
    stat = base_grad3d_init(n1, n2, n3)
    stat = 0
  end function

  integer function base_lapc3d_oper(adj, add, modl, data) result(stat)
    logical                :: adj, add
    real, dimension(:,:,:) :: modl, data

    if (.not.add) then
       if (adj) then
          modl = 0.
       else
          data = 0.
       end if 
    end if
    call base_lapc3d(adj, add, modl, data)
    stat = 0
  end function

  integer function base_lapc3d_clos() result(stat)
    n1 = 0
    n2 = 0
    n3 = 0
    deallocate(temp)
    stat = base_grad3d_clos()
    stat = 0
  end function

  subroutine base_lapc3d(adj, add, modl, data)
    logical                :: adj, add
    real, dimension(:,:,:) :: modl, data

    integer                :: stat

    if (adj) then
       stat = base_grad3d_oper(F, F  , data, temp)
       stat = base_grad3d_oper(T, add, modl, temp)
    else
       stat = base_grad3d_oper(F, F  , modl, temp)
       stat = base_grad3d_oper(T, add, data, temp)
    end if

  end subroutine


end module
