module base_poldiv_mod
  use  base_hlxtyp_mod
  implicit none

  type(helix)                           , private :: aa
  real                                  , private :: a0
  integer                               , private :: nd   
  real       , dimension(:), allocatable, private :: tt
contains

  integer function base_poldiv_init(aa_in, a0_in, nd_in) result(stat)
    type(helix) :: aa_in
    real        :: a0_in
    integer     :: nd_in
    aa = aa_in 
    a0 = a0_in
    nd = nd_in
    if (.not.allocated(tt)) then
       allocate(tt(nd))
    end if 
    stat = 0
  end function

  integer function base_poldiv_clos() result(stat)
    deallocate(tt)
    stat = 0 
  end function

  integer function base_poldiv_oper(adj, add, xx, yy) result(stat)
    logical            :: adj, add 
    real, dimension(:) :: xx, yy
    integer            :: ix, iy, ia
    if (.not.add) then
       if (adj) then
          xx = 0.
       else
          yy = 0.
       end if 
    end if

    tt = 0.
    if (adj) then
       tt = yy
       do iy=nd, 1, -1
          do ia=1, size(aa%lag)
             ix = iy - aa%lag(ia)
             if (ix<1) cycle
             tt(ix) = tt(ix) - aa%flt(ia)*tt(iy)  
          end do
       end do
       xx = xx + tt/a0

    else
      tt = xx/a0
      do iy=1, nd
         do ia=1, size(aa%lag)
            ix = iy - aa%lag(ia)
            if (ix<1) cycle
            tt(iy) = tt(iy) - aa%flt(ia)*tt(ix)
         end do
      end do
      yy = yy + tt
    end if
    stat = 0
  end function

end module
