program main
  use bwi_kernel_mod

  type(dat_grid)   :: dgrid
  type(pro_grid)   :: pgrid
  type(vel_grid)   :: vgrid
  type(img_grid)   :: igrid
  type(hes_grid)   :: hgrid
  type(cef_grid)   :: cgrid
  type(bwi_ftag)   :: ftag_

  logical          :: adj, add
  integer          :: stat

  complex, dimension(:), allocatable :: dat1, dat2
  complex, dimension(:), allocatable :: mod1, mod2
  real   , dimension(:), allocatable :: rda1, rda2, rmo1, rmo2

  logical, parameter              :: T = .true., F = .false.

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()


  stat = bwi_kernel_init(dgrid, pgrid, vgrid, igrid, hgrid, cgrid, ftag_) 

  allocate(mod1(igrid%ax%n*igrid%ay%n*igrid%az%n*igrid%ahx%n*igrid%ahy%n*igrid%asx%n*igrid%asy%n))
  allocate(mod2(igrid%ax%n*igrid%ay%n*igrid%az%n*igrid%ahx%n*igrid%ahy%n*igrid%asx%n*igrid%asy%n))
  allocate(rmo1(igrid%ax%n*igrid%ay%n*igrid%az%n*igrid%ahx%n*igrid%ahy%n*igrid%asx%n*igrid%asy%n)) 
  allocate(rmo2(igrid%ax%n*igrid%ay%n*igrid%az%n*igrid%ahx%n*igrid%ahy%n*igrid%asx%n*igrid%asy%n))
  allocate(dat1(dgrid%asx%n*dgrid%asy%n*dgrid%agx%n*dgrid%agy%n*dgrid%aw%n))
  allocate(dat2(dgrid%asx%n*dgrid%asy%n*dgrid%agx%n*dgrid%agy%n*dgrid%aw%n))
  allocate(rda1(dgrid%asx%n*dgrid%asy%n*dgrid%agx%n*dgrid%agy%n*dgrid%aw%n))
  allocate(rda2(dgrid%asx%n*dgrid%asy%n*dgrid%agx%n*dgrid%agy%n*dgrid%aw%n))

!  call random_seed()

  call random_number(rmo1)
  call random_number(rmo2)
  call random_number(rda1)
  call random_number(rda2)

  mod1 = cmplx(rmo1,rmo2)
  dat2 = cmplx(rda1,rda2)

! adjoint
  call sseek(ftag_%crec_, 0, 0)
  call sep_write(dat2, ftag_%crec_, esize=8)

  stat = bwi_kerimg_oper(T, F, ftag_%csou_, ftag_%crec_, ftag_%bvel_, ftag_%beta_, ftag_%bdel_, ftag_%bimg_)

  call sseek(ftag_%bimg_, 0, 0)
  call sep_read(mod2, ftag_%bimg_)

! forward
  call sseek(ftag_%bimg_, 0, 0)
  call sep_write(mod1, ftag_%bimg_, esize=8)

  stat = bwi_kerimg_oper(F, F, ftag_%csou_, ftag_%crec_, ftag_%bvel_, ftag_%beta_, ftag_%bdel_, ftag_%bimg_)
  
  call sseek(ftag_%crec_, 0, 0)
  call sep_read(dat1, ftag_%crec_)


  write(0,*) sum(conjg(mod1)*mod2), sum(conjg(dat1)*dat2)

  stat = bwi_kernel_clos()

end program
