module bwi_diphlx_mod2
  use  base_struct_mod
  use  base_hlxtyp_mod
  use  base_wilson_mod
  implicit none

  type(helix), private :: dipflt
  real       , private :: dipflt0
  type(axis) , private :: adipx, adipy
  real       , private :: dipeps
  real       , private :: d1, d2, d3
  integer    , private :: n1, n2, na, niter
contains

  integer function bwi_diphlx_init(adipx_in, adipy_in, dipeps_in, d1_in, d2_in, d3_in, n1_in, n2_in, na_in, niter_in) result(stat)
    type(axis) :: adipx_in, adipy_in
    real       :: dipeps_in
    real       :: d1_in, d2_in, d3_in
    integer    :: n1_in, n2_in, na_in, niter_in
 
    adipx  = adipx_in
    adipy  = adipy_in
    dipeps = dipeps_in
    d1     = d1_in
    d2     = d2_in
    d3     = d3_in
    n1     = n1_in
    n2     = n2_in
    na     = na_in
    niter  = niter_in
    call allocatehelix(dipflt, 5)
    stat = 0
  end function

  integer function bwi_diphlx_clos() result(stat)
    call deallocatehelix(dipflt)
    stat = 0
  end function

  integer function bwi_diphlx_oper(dipfac, dipfac0) result(stat)
    type(helix), dimension(:,:) :: dipfac
    real       , dimension(:,:) :: dipfac0
 
    integer                   :: idipx, idipy, ia
    real                      :: dipx, dipy, PI
    real                      :: vx1, vx2, vy1, vy2

    PI = 3.14159265359

dipflt%lag(1) = 1
dipflt%lag(2) = n1
dipflt%lag(3) = n1*n2-n1
dipflt%lag(4) = n1*n2-1
dipflt%lag(5) = n1*n2

    stat = base_wilson_init(maxval(dipflt%lag)+1)
!   the first 1 to n-1 are dip filters
!   ----------------------------------
    do idipy=1, adipy%n; dipy = adipy%o+(idipy-1)*adipy%d
    do idipx=1, adipx%n; dipx = adipx%o+(idipx-1)*adipx%d

       vx1 = cos(dipx*PI/180.)/d1
       vx2 = sin(dipx*PI/180.)/d3
       vy1 = cos(dipy*PI/180.)/d2
       vy2 = sin(dipy*PI/180.)/d3
!       if (dip < 0.) then
!          f11 = 0
!          f12 = -v1
!          f21 = -v2
!          f22 = v1+v2
!       else
!          f11 = -v1
!          f12 = 0.
!          f21 = v1-v2
!          f22 = v2
!       end if

dipflt0 = vx1*vx1+vx2*vx2+(vx1+vx2)*(vx1+vx2) &
        + vy1*vy1+vy2*vy2+(vy1+vy2)*(vy1+vy2) &
        + dipeps
dipflt%flt(1) = -vx1*(vx1+vx2)
dipflt%flt(2) = -vy1*(vy1+vy2)
dipflt%flt(3) = vy1*vy2
dipflt%flt(4) = vx1*vx2
dipflt%flt(5) = -vx2*(vx1*vx2)-vy2*(vy1+vy2)


       dipfac0(idipx,idipy)    = 0.
       dipfac(idipx,idipy)%flt = 0.
       do ia=1, na
          dipfac(idipx,idipy)%lag(ia)      = ia
          dipfac(idipx,idipy)%lag(na+ia)   = n1+ia-na
          dipfac(idipx,idipy)%lag(2*na+ia) = n1+ia
          dipfac(idipx,idipy)%lag(3*na+ia) = n1*n2-n1+ia-na
          dipfac(idipx,idipy)%lag(4*na+ia) = n1*n2-n1+ia
          dipfac(idipx,idipy)%lag(5*na+ia) = n1*n2+ia-na
          dipfac(idipx,idipy)%lag(6*na+ia) = n1*n2+ia
          dipfac(idipx,idipy)%lag(7*na+ia) = n1*n2+n1+ia-na
          dipfac(idipx,idipy)%lag(8*na+ia) = n1*n2+n1+ia
       end do

       stat = base_wilson_oper(niter, dipflt0, dipflt, dipfac0(idipx,idipy), dipfac(idipx,idipy))
    end do
    end do

    stat = base_wilson_clos()
    stat = 0
  end function

end module
