module bwi_hlxcon_mod
  use  base_hlxtyp_mod
  use  base_codtrs_mod
  implicit none

  type(helix), dimension(:)    , pointer, private :: hlxflt
  real       , dimension(:)    , pointer, private :: hlxflt0
  integer    , dimension(:,:,:), pointer, private :: selc
  integer                               , private :: nx, ny, nz, nd   
contains


  integer function bwi_hlxcon_init(hlxflt_in, hlxflt0_in, selc_in, nx_in, ny_in, nz_in) result(stat)
    type(helix), dimension(:)    , target :: hlxflt_in
    real       , dimension(:)    , target :: hlxflt0_in
    integer    , dimension(:,:,:), target :: selc_in
    integer                               :: nx_in, ny_in, nz_in
    hlxflt  => hlxflt_in 
    hlxflt0 => hlxflt0_in
    selc    => selc_in
    nx      =  nx_in
    ny      =  ny_in
    nz      =  nz_in

    nd = nx*ny*nz

write(0,*)"nx,ny,nz", nx,ny,nz

    stat = 0
  end function

  integer function bwi_hlxcon_clos() result(stat)
    stat = 0 
  end function

  integer function bwi_hlxcon_oper(adj, add, xx, yy) result(stat)
    logical                        :: adj, add 
    real, dimension(:,:,:)         :: xx, yy
    integer                        :: ix, iy, ia

    integer                        :: iselc
    integer, dimension(3)          :: nn, ii, jj
    integer, dimension(:), pointer :: lag
    real   , dimension(:), pointer :: flt
    real                           :: flt0

    nn = (/nx,ny,nz/)

    if (.not.add) then
       if (adj) then
          xx = 0.
       else
          yy = 0.
       end if 
    end if

    do iy=1, nd
       call line2cart(nn, iy, ii)
       iselc = selc(ii(1),ii(2),ii(3)) 
       lag  => hlxflt(iselc)%lag 
       flt  => hlxflt(iselc)%flt
       flt0 =  hlxflt0(iselc)
!      zero lag
       if (adj) then
          xx(ii(1),ii(2),ii(3)) = xx(ii(1),ii(2),ii(3)) + flt0*yy(ii(1),ii(2),ii(3))
       else
          yy(ii(1),ii(2),ii(3)) = yy(ii(1),ii(2),ii(3)) + flt0*xx(ii(1),ii(2),ii(3))
       end if
       do ia=1, size(lag)
          ix = iy - lag(ia)
          call line2cart(nn, ix, jj)
          if (ix<1) cycle
          if (adj) then
             xx(jj(1),jj(2),jj(3)) = xx(jj(1),jj(2),jj(3)) + flt0*flt(ia)*yy(ii(1),ii(2),ii(3))
          else
             yy(ii(1),ii(2),ii(3)) = yy(ii(1),ii(2),ii(3)) + flt0*flt(ia)*xx(jj(1),jj(2),jj(3))
          end if  
       end do
    end do

    stat = 0
  end function

end module
