program main
  use bwi_dipcal_mod
  use bwi_dipflt_mod2
  use base_ioutil_mod
  use solver_smp_mod
  use cgstep_mod
  use lapfac
  implicit none

  type(axis) :: ax, ay, az
  integer    :: rect1, rect2, rect3, nsmt, stat, iz
  real, dimension(:)    , allocatable :: f, g
  real, dimension(:,:,:), allocatable :: v, r, rr
  logical                             :: dipin

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()

  call from_param("rect1", rect1, 1)
  call from_param("rect2", rect2, 1)
  call from_param("rect3", rect3, 1)
  call from_param("nsmt" , nsmt , 1)
  call from_param("dipin", dipin, .false.)

  call auxinout("f")
  call auxinout("g")
  call auxinout("dip")
  call auxinout("ref")

  call hinaxis("f", ax, 1)
  call hinaxis("f", ay, 2)
  call hinaxis("f", az, 3) 

  call houaxis("g", ax, 1)
  call houaxis("g", ay, 2)
  call houaxis("g", az, 3)

  allocate(f(ax%n*ay%n*az%n))
  allocate(g(ax%n*ay%n*az%n))
  allocate(v(ax%n,ay%n,az%n))
  allocate(r(ax%n,ay%n,az%n))
  allocate(rr(ax%n,ay%n,az%n))

  call sep_read(f, "f")
  call sep_read(r, "ref")

  if (dipin) then
     call sep_read(v, "dip")
     v = v/sqrt(1+v*v)
  else
     call houaxis("dip", ax, 1)
     call houaxis("dip", ay, 2)
     call houaxis("dip", az, 3)
     stat = bwi_dipcal_init(ax, ay, az, rect1, rect2, rect3, nsmt)
     stat = bwi_dipcal_oper(r, v)
     stat = bwi_dipcal_clos()
     call sep_write(r, "dip")
  end if

  stat = bwi_dipflt_init(v, ax, ay, az)

!  call random_number(f)


  call solver_smp(m=g, d=f, Fop=bwi_dipflt_oper, stepper=cgstep, niter=500, verb=.true.)

  call sep_write(g, "g")


end program
