program main
  use base_struct_mod
  use base_ioutil_mod
  implicit none

  type(vel_grid)                  :: vgrid
  type(axis)                      :: aiter
  character(len=256)              :: mmov_, fmov_
  real, dimension(:), allocatable :: bvel, fmov
  integer                         :: niter, iter

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()

  mmov_ = "mmov"
  fmov_ = "fmov"

  call from_param("nx"   , vgrid%ax%n, 1 )
  call from_param("dx"   , vgrid%ax%d, 1.)
  call from_param("ox"   , vgrid%ax%o, 0.)
  call from_param("ny"   , vgrid%ay%n, 1 )
  call from_param("dy"   , vgrid%ay%d, 1.)
  call from_param("oy"   , vgrid%ay%o, 0.)
  call from_param("nz"   , vgrid%az%n, 1 )
  call from_param("dz"   , vgrid%az%d, 1.)
  call from_param("oz"   , vgrid%az%o, 0.)
  call from_param("niter", niter     , 1 )

  aiter%n = niter+1; aiter%d = 1.; aiter%o = 0.;

  allocate(bvel(vgrid%ax%n*vgrid%ay%n*vgrid%az%n))
  allocate(fmov(niter+1))

  call auxinout(mmov_)
  call auxinout(fmov_)

  call houaxis(mmov_, vgrid%ax, 1)
  call houaxis(mmov_, vgrid%ay, 2)
  call houaxis(mmov_, vgrid%az, 3)
  call houaxis(mmov_, aiter   , 4)

  call houaxis(fmov_, aiter   , 1)  

  do iter=1, aiter%n
     call sep_write(bvel, mmov_)
  end do

  call sep_write(fmov, fmov_)

  call sep_end_prog()
 
  call exit()

end program
