program main
  use sep
  use base_struct_mod
  use base_spline_mod
  use base_ioutil_mod
  implicit none

  type(axis)                          :: axd, ayd, azd, axk, ayk, azk
  real, dimension(:,:,:), allocatable :: data, modl
  real                                :: xk_min, yk_min, zk_min
  real                                :: xk_max, yk_max, zk_max
  logical                             :: adj
  integer                             :: stat

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()


  call from_param("adj", adj, .true.)

  if (adj) then
     call from_param("xk_min",xk_min,0.); call from_param("xk_max",xk_max,0.); call from_param("nxk",axk%n,1)
     call from_param("yk_min",yk_min,0.); call from_param("yk_max",yk_max,0.); call from_param("nyk",ayk%n,1)
     call from_param("zk_min",zk_min,0.); call from_param("zk_max",zk_max,0.); call from_param("nzk",azk%n,1)
     axk%o = xk_min; axk%d = 1.
     ayk%o = yk_min; ayk%d = 1.
     azk%o = zk_min; azk%d = 1.
     if (axk%n>1) then
        axk%o = xk_min; axk%d = (xk_max-xk_min)/(axk%n-1)
     end if
     if (ayk%n>1) then
        ayk%o = yk_min; ayk%d = (yk_max-yk_min)/(ayk%n-1)
     end if
     if (azk%n>1) then
        azk%o = zk_min; azk%d = (zk_max-zk_min)/(azk%n-1)
     end if

     call hinaxis("data", axd, 1); call hinaxis("data", ayd, 2); call hinaxis("data", azd, 3)
     call houaxis("modl", axk, 1); call houaxis("modl", ayk, 2); call houaxis("modl", azk, 3)

  else

     call from_param("nxd", axd%n, 1); call from_param("dxd", axd%d, 1.); call from_param("oxd", axd%o, 0.)
     call from_param("nyd", ayd%n, 1); call from_param("dyd", ayd%d, 1.); call from_param("oyd", ayd%o, 0.)
     call from_param("nzd", azd%n, 1); call from_param("dzd", azd%d, 1.); call from_param("ozd", azd%o, 0.)

     call hinaxis("modl", axk, 1); call hinaxis("modl", ayk, 2); call hinaxis("modl", azk, 3)
     call houaxis("data", axd, 1); call houaxis("data", ayd, 2); call houaxis("data", azd, 3)

  end if  

  allocate(modl(axk%n,ayk%n,azk%n), data(axd%n,ayd%n,azd%n))

  stat = base_spln3d_init(axd, ayd, azd, axk, ayk, azk)

  if (adj) then
     call sep_read(data, "data")
  else
     call sep_read(modl, "modl")
  end if

  stat = base_spln3d_oper(adj, .false., modl, data)

  if (adj) then
     call sep_write(modl, "modl")
  else
     call sep_write(data, "data")
  end if

end program
