program main

  use sep
  use killwave_ns
  use steer_mod

  implicit none

  character (len=64)				:: dip_, infile_, outfile_
  real, allocatable			     	:: A (:,:),ATA(:,:),FILT(:,:),infile(:), outfile(:)
  type( filter)     			  	:: hfilt
  real		  						:: eps
  real                     			:: d1, d2, d3, o1, o2, o3
  integer                   		:: n1, n2, n3
  real                     			:: dang, oang
  integer                  			:: nang, nfilt
  integer                  			:: verb 
  logical							:: randin, lscale
  integer,allocatable				:: ptch(:), filt_len(:)
  real   ,allocatable				:: dips(:)
  real	 , parameter				:: pi=3.14159

  call initpar()
  dip_='dip'; infile_='infile'; outfile_='outfile'

	call from_param('eps  ',eps ,        0.001)
	call from_param('nang ',nang ,       360 )
	call from_param('nfilt',nfilt,         14)
	call from_param('verb' ,verb,           1)
	call from_param('rand_in',randin, .false.)
	call from_param('lscale', lscale, .false.)


	if (.not.exist_file(dip_)) call seperr("dip field doesn't exist")	

    if (exist_file(infile_))then
        call from_aux(infile_,"n1",n1); call from_aux(infile_,"d1",d1); call from_aux(infile_,"o1",o1)
        call from_aux(infile_,"n2",n2); call from_aux(infile_,"d2",d2); call from_aux(infile_,"o2",o2)
        call from_aux(infile_,"n3",n3); call from_aux(infile_,"d3",d3); call from_aux(infile_,"o3",o3)
        allocate(   dips(n1*n2*n3)); 
        allocate( infile(n1*n2*n3)); 
        allocate(outfile(n1*n2*n3)); 
        call sep_read(infile, infile_)
    else
        call from_param('n1',n1, 64); call from_param('d1',d1, 10.); call from_param('o1',o1, 0.); 
        call from_param('n2',n2, 32); call from_param('d2',d2, 10.); call from_param('o1',o1, 0.); 
        call from_param('n3',n3, 1 ); call from_param('d3',d3, 10.); call from_param('o1',o1, 0.); 
        allocate(   dips(n1*n2*n3)); 
        allocate( infile(n1*n2*n3) ); 
        allocate(outfile(n1*n2*n3) ); 
        call random_number(infile)
   endif        

   allocate(ptch(n1*n2*n3))
   allocate(filt_len(nang)); filt_len = 3*nfilt

   where(dips < -1.570) dips=-1.5708
   where(dips >  1.570) dips= 1.5708
   oang = minval(dips)
   dang = (maxval(dips)-minval(dips)) / (nang-1)

   call steer_init(nang,nfilt)
