program main
  use sep
  use killwave_mod
  use steer_ns
  use solver_prc_mod
  use cgstep_mod

  implicit none

  integer				:: nparam, niter
  integer                     		:: invflag 
  

  call initpar()
  call from_param('nparam',nparam,6)
  call from_param('niter' ,niter ,6)
  call from_param('flag', invflag,1)  !.. 1 inv steering filter 2 inv steer and stdv

    dip_='dip'; A_='A'; ATA_='ATA';  FILT_='FILT'; infile_='infile'; outfile_='outfile'

    if (exist_file(infile_))then
        call from_aux(infile_,"n1",n1); call from_aux(infile_,"d1",d1); call from_aux(infile_,"o1",o1)
        call from_aux(infile_,"n2",n2); call from_aux(infile_,"d2",d2); call from_aux(infile_,"o2",o2)
        call from_aux(infile_,"n3",n3); call from_aux(infile_,"d3",d3); call from_aux(infile_,"o3",o3)
        allocate(   dips(n1*n2*n3)); 
        allocate( infile(n1*n2*n3)); 
        allocate(outfile(n1*n2*n3)); 
        call sep_read(infile, infile_)
        if(exist_file(dip_))call sep_read(dips,dip_)
    else
        call from_param('n1',n1, 64); call from_param('d1',d1, 10.); call from_param('o1',o1, 0.); 
        call from_param('n2',n2, 32); call from_param('d2',d2, 10.); call from_param('o1',o1, 0.); 
        call from_param('n3',n3, 1 ); call from_param('d3',d3, 10.); call from_param('o1',o1, 0.); 
        allocate(   dips(n1*n2*n3)); 
        allocate( infile(n1*n2*n3) ); 
        allocate(outfile(n1*n2*n3) ); 
        if(exist_file(dip_))call sep_read(dips,dip_)
        call random_number(infile)
   endif        
   outfile=0

   call params()
   where(dips < -1.570) dips=-1.5708
   where(dips >  1.570) dips= 1.5708

   oang = minval(dips)
   dang = (maxval(dips)-minval(dips)) / (nang-1)
   write(0,*) "oang", oang
   write(0,*) "max ang", maxval(dips), oang + (nang-1)*dang

   if (rand_in)call random_number(infile)

   call ns_init()
   call ns_lop()


   call npolydiv_init(n1*n2,n_filt)
   call prior_init(n1*n2,nparam)
   call weight_init(n1*n2,nparam)

   if (invflag .eq. 1) then
      call solver_prc(outfile, infile, Identity, filt_npolydiv3, cgstep, n1*n2*n3&
           &,niter, eps, Wop=weight, verb=.true.)
   else
      call solver_prc(outfile, infile, Identity, filt_npolydiv3, cgstep, n1*n2*n3&
           &,niter, eps, Wop=weight, Jop=prior_stdv, verb=.true.)
   end if

   call nhelicon_init(n_filt)
   stat = nhelicon_lop(.false.,.false.,outfile,infile)
  
   outfile = infile

   call srite("outfile", outfile, 4*n1*n2*n3)
   call npolydiv_close()
   stat = prior_clos()

end program
