program main 

  use sep

  implicit none

  integer                                :: n1, n2, n3
  real                                   :: o1, o2, o3, d1, d2, d3
  integer                                :: i1, i2, i3 
  real,allocatable                       :: img1(:,:,:), img2(:,:,:), imgo(:,:,:)
  integer								 :: wind
  real									 :: corr, mean1, mean2, sigm1, sigm2, eps

  call initpar()
  call from_history("n1", n1)   ! x
  call from_history("n2", n2)   ! y
  call from_history("n3", n3)   ! z
  call from_history("o1", o1)
  call from_history("o2", o2)
  call from_history("o3", o3)
  call from_history("d1", d1)
  call from_history("d2", d2)
  call from_history("d3", d3)

  call from_param("wind",wind, 3)
  call from_param("eps" , eps, 0.001)

  allocate(img1(n1,n2,n3), img2(n1,n2,n3), imgo(n1,n2,n3))
  call sep_read(img1)
  call sreed("matchimg",img2,4*n1*n2*n3)

  do i3=1+wind,n3-wind
      do i2 = 1+wind, n2-wind
          do i1 = 1+wind, n1-wind
			mean1 = sum(abs(img1(i1-wind:i1+wind,i2-wind:i2+wind,i3-wind+i3+wind)))
			mean2 = sum(abs(img2(i1-wind:i1+wind,i2-wind:i2+wind,i3-wind+i3+wind)))	  
			imgo(i1,i2,i3) = img1(i1,i2,i3)*mean2/(mean1+eps)
          end do
      end do
  end do

  call sep_write(imgo)

  call to_history("n1", n1)
  call to_history("n2", n2)
  call to_history("n3", n3)
  call to_history("d1", d1)
  call to_history("d2", d2)
  call to_history("d3", d3)
  call to_history("o1", o1)
  call to_history("o2", o2)
  call to_history("o3", o3)
  call to_history("esize", 4)

  deallocate(img1,img2,imgo)
end program  
