program main 

  use sep

  implicit none

  integer                                :: n1, n2, n3
  real                                   :: o1, o2, o3, d1, d2, d3
  integer                                :: i, j, k, z_seabed
  real,allocatable                       :: del(:,:,:), eps(:,:,:)
  real                                   :: min_e, min_d 
  real                                   :: max_e, max_d 

  call initpar()

  call auxinout("eps")
  call auxinout("del")

  call from_aux("del", "n1", n1)
  call from_aux("del", "n2", n2)
  call from_aux("del", "n3", n3)
  call from_aux("del", "o1", o1)
  call from_aux("del", "o2", o2)
  call from_aux("del", "o3", o3)
  call from_aux("del", "d1", d1)
  call from_aux("del", "d2", d2)
  call from_aux("del", "d3", d3)
  call from_param("min_e", min_e, 0.)      ! .. min bound of eps
  call from_param("max_e", max_e, 0.25)    ! .. max bound of eps
  call from_param("min_d", min_d, -0.004)  ! .. min bound of delta
  call from_param("max_d", max_d, 0.2)     ! .. max bound of delta



  allocate(del(n1,n2,n3),eps(n1,n2,n3))

  call sreed("del",del,4*n1*n2*n3)
  call sreed("eps",eps,4*n1*n2*n3)

  ! mask for velocity down to the sea bottom
  where(eps<min_e)
    eps=min_e
  end where
  where(eps>max_e)
    eps=max_e
  end where

  where(del<min_d)
    del=min_d
  end where
  where(del>max_d)
    del=max_d
  end where

  call sseek("del",0,0)
  call sseek("eps",0,0)
  call srite("del", del, 4*n1*n2*n3)
  call srite("eps", eps, 4*n1*n2*n3)

  deallocate(eps,del)
end program  
