program main 

  use sep

  implicit none

  integer                                :: n1, n2, n3
  real                                   :: o1, o2, o3, d1, d2, d3
  integer                                :: i, j, k, z_seabed
  real,allocatable                       :: vel(:,:,:), eta(:,:,:)
  real,allocatable                       :: maskv(:,:,:),maske(:,:,:)
  real                                   :: minv_sed, mine_sed 
  real                                   :: minx_v, maxx_v, miny_v, maxy_v, minz_v, maxz_v 
  real                                   :: minx_e, maxx_e, miny_e, maxy_e, minz_e, maxz_e 
  real                                   :: minx_d, maxx_d, miny_d, maxy_d, minz_d, maxz_d 
  integer                                :: ixbeg,  ixend,  iybeg,  iyend,  izbeg,  izend  

  call initpar()
  call from_history("n1", n1)
  call from_history("n2", n2)
  call from_history("n3", n3)
  call from_history("o1", o1)
  call from_history("o2", o2)
  call from_history("o3", o3)
  call from_history("d1", d1)
  call from_history("d2", d2)
  call from_history("d3", d3)
  call from_param("minv_sed", minv_sed, 1600.)  ! .. min sediment velocity
  call from_param("mine_sed", mine_sed, 0.001)  ! .. min sediment eta 

  ! get the spatial dimension for masking
  call from_param("minx_v", minx_v, o1)
  call from_param("maxx_v", maxx_v, o1+(n1-1)*d1)
  call from_param("miny_v", miny_v, o2)
  call from_param("maxy_v", maxy_v, o2+(n2-1)*d2)
  call from_param("minz_v", minz_v, o3)
  call from_param("maxz_v", maxz_v, o3+(n3-1)*d3)

  call from_param("minx_e", minx_e, o1)
  call from_param("maxx_e", maxx_e, o1+(n1-1)*d1)
  call from_param("miny_e", miny_e, o2)
  call from_param("maxy_e", maxy_e, o2+(n2-1)*d2)
  call from_param("minz_e", minz_e, o3)
  call from_param("maxz_e", maxz_e, o3+(n3-1)*d3)

  call from_param("minx_d", minx_d, o1)
  call from_param("maxx_d", maxx_d, o1+(n1-1)*d1)
  call from_param("miny_d", miny_d, o2)
  call from_param("maxy_d", maxy_d, o2+(n2-1)*d2)
  call from_param("minz_d", minz_d, o3)
  call from_param("maxz_d", maxz_d, o3+(n3-1)*d3)

  allocate(vel(n1,n2,n3),eta(n1,n2,n3), maskv(n1,n2,n3),maske(n1,n2,n3))
  write(0,*) n1, n2, n3

  call sep_read(vel)
!  call sreed("beta",eta,4*n1*n2*n3)

  maskv=1.
  maske=1.

  ! mask for velocity down to the sea bottom
  where(vel<minv_sed)
    maskv=0.
  end where
  where(vel>4200)
    maskv=0.
  end where
  ! mask the spatial area
  if(1==2) then
  ixbeg = max(1,  int((minx_v - o1)/d1+1.))
  ixend = min(n1, int((maxx_v - o1)/d1+1.))
  iybeg = max(1,  int((miny_v - o2)/d2+1.))
  iyend = min(n2, int((maxy_v - o2)/d2+1.))
  izbeg = max(1,  int((minz_v - o3)/d3+1.))
  izend = min(n3, int((maxz_v - o3)/d3+1.))
write(0,*) ixbeg, ixend, iybeg, iyend, izbeg, izend
  if (n1>1) then
    maskv(1:ixbeg,:,: ) = 0.;
    maskv(ixend:n1,:,:) = 0.;
  end if
  if (n2>1) then
    maskv(:,1:iybeg,: ) = 0.;
    maskv(:,iyend:n2,:) = 0.;
  end if
  if (n3>1) then
    maskv(:,:,1:izbeg ) = 0.;
    maskv(:,:,izend:n3) = 0.;
  end if
  ! mask for eta=0
  where(eta<mine_sed)
    maske=0.
  end where
  ! mask the spatial area
  ixbeg = max(1,  int((minx_e - o1)/d1+1.))
  ixend = min(n1, int((maxx_e - o1)/d1+1.))
  iybeg = max(1,  int((miny_e - o2)/d2+1.))
  iyend = min(n2, int((maxy_e - o2)/d2+1.))
  izbeg = max(1,  int((minz_e - o3)/d3+1.))
  izend = min(n3, int((maxz_e - o3)/d3+1.))
write(0,*) ixbeg, ixend, iybeg, iyend, izbeg, izend
  if (n1>1) then
    maske(1:ixbeg,:,: ) = 0.;
    maske(ixend:n1,:,:) = 0.;
  end if
  if (n2>1) then
    maske(:,1:iybeg,: ) = 0.;
    maske(:,iyend:n2,:) = 0.;
  end if
  if (n3>1) then
    maske(:,:,1:izbeg ) = 0.;
    maske(:,:,izend:n3) = 0.;
  end if
  end if
  call sep_write(maskv)
!  call srite("maske", maske, 4*n1*n2*n3)

  call to_history("n1", n1)
  call to_history("n2", n2)
  call to_history("n3", n3)
  call to_history("d1", d1)
  call to_history("d2", d2)
  call to_history("d3", d3)
  call to_history("o1", o1)
  call to_history("o2", o2)
  call to_history("o3", o3)
  call to_history("esize", 4)

!  call to_history("n1", n1, "maske")
!  call to_history("n2", n2, "maske")
!  call to_history("n3", n3, "maske")
!  call to_history("d1", d1, "maske")
!  call to_history("d2", d2, "maske")
!  call to_history("d3", d3, "maske")
!  call to_history("o1", o1, "maske")
!  call to_history("o2", o2, "maske")
!  call to_history("o3", o3, "maske")
!  call to_history("esize", 4, "maske")

!  deallocate(vel,eta,maskv,maske)
end program  
