program main 

  use sep

  implicit none

  integer                                :: n1, n2, n3
  real                                   :: o1, o2, o3, d1, d2, d3
  integer                                :: nkeep, i2, ikeep 
  real,allocatable                       :: vel(:,:,:), subvel(:,:,:), randtr(:)
  real,allocatable                       :: wght(:,:,:)
  real                                   :: minv_sed, mine_sed 
  integer                                :: ixbeg,  ixend,  iybeg,  iyend,  izbeg,  izend  

  call initpar()
  call from_history("n1", n1)   ! z
  call from_history("n2", n2)   ! x
  call from_history("n3", n3)
  call from_history("o1", o1)
  call from_history("o2", o2)
  call from_history("o3", o3)
  call from_history("d1", d1)
  call from_history("d2", d2)
  call from_history("d3", d3)
  call from_param("nkeep", nkeep, 50)  ! .. number of traces to keep 

  allocate(vel(n1,n2,n3), subvel(n1,n2,n3), wght(n1,n2,n3))
  allocate(randtr(nkeep))
  write(0,*) n1, n2, n3

  call sep_read(vel)
  subvel = 0; 
  wght = 0;
  
  call random_number(randtr)
  randtr = randtr * n2

  do ikeep = 1, nkeep
      i2 = ceiling(randtr(ikeep))
      write(0,*) i2
      if (i2.le.n2 .and. i2.ge.1) then
        write(0,*) i2
        subvel(:,i2,:) = vel(:,i2,:)
        wght  (:,i2,1) = 1
      end if
  end do

  write(0,*) sum(subvel)
  call sep_write(subvel)
  call srite("wght",wght,4*n1*n2*n3)

  call to_history("n1", n1)
  call to_history("n2", n2)
  call to_history("n3", n3)
  call to_history("d1", d1)
  call to_history("d2", d2)
  call to_history("d3", d3)
  call to_history("o1", o1)
  call to_history("o2", o2)
  call to_history("o3", o3)
  call to_history("esize", 4)

  call to_history("n1", n1, "wght")
  call to_history("n2", n2, "wght")
  call to_history("n3", n3, "wght")
  call to_history("d1", d1, "wght")
  call to_history("d2", d2, "wght")
  call to_history("d3", d3, "wght")
  call to_history("o1", o1, "wght")
  call to_history("o2", o2, "wght")
  call to_history("o3", o3, "wght")
  call to_history("esize", 4, "wght")

  deallocate(vel,subvel,wght)
end program  
