module base_window_mod
  implicit none

contains

  !----------------------------------------------
  ! Hamming window, left half
  !----------------------------------------------
  subroutine hammiwin1d(win, n)
    real, dimension(:) :: win
    integer            :: n
    integer            :: i
    real               :: PI

    PI = 3.14159265359
    if (n == 1) then
       win(1) = 1.
    else 
       do i=1, n
          win(i) = 0.54 + 0.46*cos(PI*(i-1)/(n-1)-PI)
       end do
    end if
    return
  end subroutine

  subroutine blackmanwin1d(win,n)
    real, dimension(:) :: win
    integer            :: n
    integer            :: i
    real               :: PI, a0, a1, a2

    PI = 3.14159265359
	a0 = 0.42659
	a1 = 0.49656
	a2 = 0.076849

    if (n == 1) then
       win(1) = 1.
    else 
       do i=1, n
          win(i) = a0 - a1*cos(PI*(n-i)/(n-1)-PI) + a2*cos(2*PI*(n-i)/(n-1)-2*PI)
       end do
    end if
    return
  end subroutine

end module
