program main 

  use sep

  implicit none

  real, allocatable                     :: dat(:,:,:,:,:)
  integer                               :: n1out, n2out
  real                                  :: d1, o1, d2, o2, d3, o3, o4, d4, o5, d5
  integer                               :: n1, n2, n3, i1, i2, i3, n4, n5, i4, i5
  integer								:: iramp, ie, itmute
  real									:: vmute, t0mute, vlow, minoff 
  real									:: tmute, zwater, tramp
  real									:: sx,sy,gx,gy 
  real, allocatable						:: damp(:)
  logical								:: innerm


  call sep_init()

  ! Get data dimensions from command line.
  call from_history("n1",n1)	    ! time       
  call from_history("n2",n2)		! off_x
  call from_history("n3",n3)		! off_y
  call from_history("n4",n4)		! s_x / cmp_x
  call from_history("n5",n5)		! s_y / cmp_y
  call from_history("o1",o1)
  call from_history("o2",o2)
  call from_history("o3",o3)
  call from_history("o4",o4)
  call from_history("o5",o5)
  call from_history("d1",d1)
  call from_history("d2",d2)
  call from_history("d3",d3)
  call from_history("d4",d4)
  call from_history("d5",d5)

  ! get the salt velocity from command line
  call from_param("vmute",  vmute ,  1470.)
  call from_param("t0mute", t0mute,  0.   ) 
  call from_param("zwater", zwater,  0.   )
  call from_param("tramp",  tramp,   0.04 )
  call from_param("inner", innerm, .false.)
  call from_param("minoff", minoff, 300.  )

  iramp = tramp / d1 + 1.5;
  allocate(damp(iramp))
  do i1 = 1,iramp
		  damp(i1) =(d1*i1/(d1*iramp+1.e-20))
  end do

  if (innerm) then
	  call from_param("vlow", vlow, 700.)
  end if


  allocate(dat(n1, n2, n3, n4, n5))
  call sep_read(dat)

  do i5=1,n5
		  do i4=1,n4
				do i3=1,n3
						gy = (i3-1)*d3 + o3
						do i2=1,n2
								gx = (i2-1)*d2 + o2 
								if (sqrt((gx)**2+(gy)**2) < minoff) then
										dat(:,i2,i3,i4,i5) = 0;
								end if
								tmute = t0mute + sqrt((gx)**2+(gy)**2+zwater**2)/vmute
								itmute = (tmute - o1)/d1 + 1.5
								dat (1:itmute,i2,i3,i4,i5) = 0
								ie=min(iramp,n1-itmute)
								dat (itmute+1:itmute+ie,i2,i3,i4,i5) = dat (itmute+1:itmute+ie,i2,i3,i4,i5)*damp(1:ie)
								if (innerm) then
										tmute  = sqrt((gx)**2+(gy)**2)/vlow
										itmute = (tmute - o1)/d1 + 1.5
										dat (itmute:n1,i2,i3,i4,i5) = 0
										ie=min(iramp,itmute)
										dat (itmute-ie+1:itmute,i2,i3,i4,i5) = dat(itmute-ie+1:itmute,i2,i3,i4,i5)*damp(ie:1:-1)
								end if		
						end do
				  end do
		  end do
  end do

  call to_history("n1",n1)             
  call to_history("n2",n2)
  call to_history("n3",n3)
  call to_history("n4",n4)
  call to_history("n5",n5)
  call to_history("o1",o1)
  call to_history("o2",o2)
  call to_history("o3",o3)
  call to_history("o4",o4)
  call to_history("o5",o5)
  call to_history("d1",d1)
  call to_history("d2",d2)
  call to_history("d3",d3)
  call to_history("d4",d4)
  call to_history("d5",d5)
  call to_history("esize", 4)

  call sep_write(dat)
  deallocate(dat)

end program 
