program main
  use bwi_kernel_mod

  type(dat_grid)   :: dgrid
  type(pro_grid)   :: pgrid
  type(vel_grid)   :: vgrid
  type(img_grid)   :: igrid
  type(hes_grid)   :: hgrid 
  type(cef_grid)   :: cgrid
  type(bwi_ftag)   :: ftag_

  logical          :: adj, add
  integer          :: stat

  real, dimension(:), allocatable :: dat1, dat2
  real, dimension(:), allocatable :: mod1_v, mod2_v
  real, dimension(:), allocatable :: mod1_e, mod2_e

  logical, parameter              :: T = .true., F = .false.
  double precision				  :: dot1, dot2

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()


  stat = bwi_kernel_init(dgrid, pgrid, vgrid, igrid, hgrid, cgrid, ftag_) 

  allocate(dat1(igrid%ax%n*igrid%ay%n*igrid%az%n*igrid%ahx%n*igrid%ahy%n*igrid%asx%n*igrid%asy%n))
  allocate(dat2(igrid%ax%n*igrid%ay%n*igrid%az%n*igrid%ahx%n*igrid%ahy%n*igrid%asx%n*igrid%asy%n))
  allocate(mod1_v(vgrid%ax%n*vgrid%ay%n*vgrid%az%n))
  allocate(mod1_e(vgrid%ax%n*vgrid%ay%n*vgrid%az%n))
  allocate(mod2_v(vgrid%ax%n*vgrid%ay%n*vgrid%az%n))
  allocate(mod2_e(vgrid%ax%n*vgrid%ay%n*vgrid%az%n))

  call random_seed()

  call random_number(dat2)

! adjoint
  call sseek(ftag_%dimg_, 0, 0)
  call sep_write(dat2, ftag_%dimg_)

  stat = bwi_kertom_oper(T, F, ftag_%csou_, ftag_%crec_, ftag_%bvel_, ftag_%beta_, ftag_%bdel_, ftag_%dvel_, ftag_%deta_, ftag_%dimg_) 

  call sseek(ftag_%dvel_, 0, 0)
  call sep_read(mod2_v, ftag_%dvel_)
  call sseek(ftag_%deta_, 0, 0)
  call sep_read(mod2_e, ftag_%deta_)

  write(0,*) sum(mod2_v), sum(mod2_e)
  write(0,*) "after adjoint"

! forward
  call random_number(mod1_v)
  call random_number(mod1_e)
  call sseek(ftag_%dvel_, 0, 0)
  call sep_write(mod1_v, ftag_%dvel_)
  call sseek(ftag_%deta_, 0, 0)
  call sep_write(mod1_e, ftag_%deta_)

  stat = bwi_kertom_oper(F, F, ftag_%csou_, ftag_%crec_, ftag_%bvel_, ftag_%beta_, ftag_%bdel_, ftag_%dvel_, ftag_%deta_, ftag_%dimg_) 

  call sseek(ftag_%dimg_, 0, 0)
  call sep_read(dat1, ftag_%dimg_)
  write(0,*) "after forward"

  dot1 = sum(mod1_v*mod2_v) + sum(mod1_e*mod2_e)
  dot2 = sum(dat1*dat2)
  write(0,*) sum(mod1_v*mod2_v) , sum(mod1_e*mod2_e)
  write(0,*) dot1, dot2

  stat = bwi_kernel_clos()

end program
