program main
  use bwi_kernel_mod_iso

  type(dat_grid)   :: dgrid
  type(pro_grid)   :: pgrid
  type(vel_grid)   :: vgrid
  type(img_grid)   :: igrid
  type(hes_grid)   :: hgrid 
  type(bwi_ftag)   :: ftag_

  logical          :: adj, add
  integer          :: stat

  real, dimension(:), allocatable :: dat1, dat2
  real, dimension(:), allocatable :: mod1, mod2

  logical, parameter              :: T = .true., F = .false.

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()


  stat = bwi_kernel_init(dgrid, pgrid, vgrid, igrid, hgrid, ftag_)

  allocate(dat1(igrid%ax%n*igrid%ay%n*igrid%az%n*igrid%ahx%n*igrid%ahy%n*igrid%asx%n*igrid%asy%n))
  allocate(dat2(igrid%ax%n*igrid%ay%n*igrid%az%n*igrid%ahx%n*igrid%ahy%n*igrid%asx%n*igrid%asy%n))
  allocate(mod1(vgrid%ax%n*vgrid%ay%n*vgrid%az%n))
  allocate(mod2(vgrid%ax%n*vgrid%ay%n*vgrid%az%n))

!  call random_seed()

  call random_number(mod1)
  call random_number(dat2)
 
! adjoint
  call sseek(ftag_%dimg_, 0, 0)
  call sep_write(dat2, ftag_%dimg_)

  stat = bwi_kertom_oper(T, F, ftag_%csou_, ftag_%crec_, ftag_%bvel_, ftag_%dvel_, ftag_%dimg_) 

  call sseek(ftag_%dvel_, 0, 0)
  call sep_read(mod2, ftag_%dvel_)

! forward
  call sseek(ftag_%dvel_, 0, 0)
  call sep_write(mod1, ftag_%dvel_)

  stat = bwi_kertom_oper(F, F, ftag_%csou_, ftag_%crec_, ftag_%bvel_, ftag_%dvel_, ftag_%dimg_)

  call sseek(ftag_%dimg_, 0, 0)
  call sep_read(dat1, ftag_%dimg_)

  write(0,*) sum(mod1*mod2), sum(dat1*dat2)

  stat = bwi_kernel_clos()

end program
