program main
  use bwi_kernel_mod

  type(dat_grid)   :: dgrid
  type(pro_grid)   :: pgrid
  type(vel_grid)   :: vgrid
  type(img_grid)   :: igrid
  type(hes_grid)   :: hgrid 
  type(cef_grid)   :: cgrid
  type(bwi_ftag)   :: ftag_

  logical          :: adj, add
  integer          :: stat

  real, dimension(:), allocatable :: dat1, dat2
  real, dimension(:), allocatable :: mod1_v, mod2_v
  real, dimension(:), allocatable :: mod1_e, mod2_e

  logical, parameter              :: T = .true., F = .false.
  double precision				  :: dot1, dot2

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()


  stat = bwi_kernel_init(dgrid, pgrid, vgrid, igrid, hgrid, cgrid, ftag_) 

  allocate(dat1(igrid%ax%n*igrid%ay%n*igrid%az%n*igrid%ahx%n*igrid%ahy%n*igrid%asx%n*igrid%asy%n))
  allocate(dat2(igrid%ax%n*igrid%ay%n*igrid%az%n*igrid%ahx%n*igrid%ahy%n*igrid%asx%n*igrid%asy%n))
  allocate(mod1_v(vgrid%ax%n*vgrid%ay%n*vgrid%az%n))
  allocate(mod1_e(vgrid%ax%n*vgrid%ay%n*vgrid%az%n))
  allocate(mod2_v(vgrid%ax%n*vgrid%ay%n*vgrid%az%n))
  allocate(mod2_e(vgrid%ax%n*vgrid%ay%n*vgrid%az%n))

  call from_param("adj",adj,.true.)


  if (adj) then
		stat = bwi_kertom_oper(T, F, ftag_%csou_, ftag_%crec_, ftag_%bvel_, ftag_%beps_, ftag_%bdel_, ftag_%dvel_, ftag_%deps_, ftag_%dimg_) 
  else	
		stat = bwi_kertom_oper(F, F, ftag_%csou_, ftag_%crec_, ftag_%bvel_, ftag_%beps_, ftag_%bdel_, ftag_%dvel_, ftag_%deps_, ftag_%dimg_) 
  end if
  stat = bwi_kernel_clos()

end program
