module bwi_hlxcon_mod
  use  base_hlxtyp_mod
  use  base_codtrs_mod
  implicit none

  type(helix), dimension(:)    , pointer, private :: dipfac
  real       , dimension(:)    , pointer, private :: dipfac0
  integer                               , private :: nx, nz, nd   
contains


  integer function bwi_hlxcon_init(dipfac_in, dipfac0_in, nx_in, nz_in) result(stat)
    type(helix), dimension(:)    , target :: dipfac_in
    real       , dimension(:)    , target :: dipfac0_in
    integer                               :: nx_in, nz_in
    dipfac  => dipfac_in 
    dipfac0 => dipfac0_in
    nx      =  nx_in
    nz      =  nz_in

    nd = nx*nz

    stat = 0
  end function

  integer function bwi_hlxcon_clos() result(stat)
    nullify(dipfac, dipfac0)
    stat = 0 
  end function

  integer function bwi_hlxcon_oper(adj, add, xx, yy, selc) result(stat)
    logical                        :: adj, add 
    real, dimension(:,:)           :: xx, yy
    integer, dimension(:,:)        :: selc 
    integer                        :: ix, iy, ia

    integer                        :: iselc
    integer, dimension(2)          :: nn, ii, jj
    integer, dimension(:), pointer :: lag
    real   , dimension(:), pointer :: flt
    real                           :: flt0

    nn = (/nx,nz/)

    if (.not.add) then
       if (adj) then
          xx = 0.
       else
          yy = 0.
       end if 
    end if

    do iy=1, nd
       call line2cart(nn, iy, ii)
       iselc = selc(ii(1),ii(2)) 
       lag  => dipfac(iselc)%lag 
       flt  => dipfac(iselc)%flt
       flt0 =  dipfac0(iselc)
!      zero lag
       if (adj) then
          xx(ii(1),ii(2)) = xx(ii(1),ii(2)) + flt0*yy(ii(1),ii(2))
       else
          yy(ii(1),ii(2)) = yy(ii(1),ii(2)) + flt0*xx(ii(1),ii(2))
       end if
       do ia=1, size(lag)
          ix = iy - lag(ia)
          call line2cart(nn, ix, jj)
          if (ix<1) cycle
          if (adj) then
             xx(jj(1),jj(2)) = xx(jj(1),jj(2)) + flt0*flt(ia)*yy(ii(1),ii(2))
          else
             yy(ii(1),ii(2)) = yy(ii(1),ii(2)) + flt0*flt(ia)*xx(jj(1),jj(2))
          end if  
       end do
    end do

    stat = 0
  end function

end module
