module bwi_sbcond_mod
  use  base_fftwv3_mod
  implicit none
  
contains

  subroutine bwi_sbcond(wfld_slice, kx2, ky2, vsfc, ws, nx, ny, plan_2dxF, plan_2dxI)
    complex, dimension(:,:)   :: wfld_slice       !!(nx,ny)
    real   , dimension(:)     :: kx2, ky2
    real                      :: vsfc, ws
    integer                   :: nws, nx, ny 
    integer*8                 :: plan_2dxF, plan_2dxI

    integer                   :: ix, iy 
    real                      :: wov, kz, kz2, kz2_max, PI

    PI      = 3.14159265359
    kz2_max = cos(85.*PI/180.)**2
    
    wov = ws/vsfc
    call sfftw_dft_2dx_oper(plan_2dxF, wfld_slice, nx, ny)

    do iy=1, ny
    do ix=1, nx
       kz2 = 1. - kx2(ix)/wov/wov - ky2(iy)/wov/wov
       if (kz2>=kz2_max) then
          kz = max(sqrt(kz2), epsilon(kz2)) 
          wfld_slice(ix,iy) = wfld_slice(ix,iy)*0.5/kz*cmplx(0,1.)
       else
          wfld_slice(ix,iy) = 0.
       end if 
    end do
    end do

    call sfftw_dft_2dx_oper(plan_2dxI, wfld_slice, nx, ny)
    return
  end subroutine 


end module
