module bwi_struct_mod
  use  base_struct_mod
  implicit none

  type bwi_ftag
    character(len=256) :: csou_             !!.. source wavefield
    character(len=256) :: crec_             !!.. receiver wavefield
    character(len=256) :: bvel_             !!.. background velocity
    character(len=256) :: beps_             !!.. background eps
    character(len=256) :: bdel_             !!.. background delta
    character(len=256) :: bimg_             !!.. background image
    character(len=256) :: dvel_             !!.. perturbed velocity
    character(len=256) :: deps_             !!.. perturbed epsilon 
    character(len=256) :: ddel_             !!.. perturbed delta 
    character(len=256) :: dimg_             !!.. perturbed image 
    character(len=256) :: bwfs_
    character(len=256) :: bwfr_
    character(len=256) :: dwfs_
    character(len=256) :: dwfr_
    character(len=256) :: srch_
    character(len=256) :: grdo_
    character(len=256) :: grdp_
    character(len=256) :: srhv_				!!.. search direction for velocity
    character(len=256) :: srhe_				!!.. search direction for eps
    character(len=256) :: srhd_				!!.. search direction for delta
    character(len=256) :: gdov_				!!.. current gradient for velocity
    character(len=256) :: gdoe_				!!.. current gradient for eps
    character(len=256) :: gdod_				!!.. current gradient for delta
    character(len=256) :: gdpv_				!!.. previous gradient for velocity
    character(len=256) :: gdpe_				!!.. previous graident for eps
    character(len=256) :: gdpd_				!!.. previous graident for delta
    character(len=256) :: gsou_
    character(len=256) :: grec_
    character(len=256) :: sfnc_
    character(len=256) :: hess_
    character(len=256) :: imsk_
    character(len=256) :: gmsk_
    character(len=256) :: vmsk_
    character(len=256) :: emsk_
    character(len=256) :: dmsk_
    character(len=256) :: hsou_				!!.. header for sources,x,y,z,nshots
    character(len=256) :: hrec_				!!.. header for receiver,x,y,z,ngx,ngy
    character(len=256) :: stdv_
    character(len=256) :: coef_				!!.. optimized coefficients
    character(len=256) :: dcef_				!!.. derivative optimized coefficients
    character(len=256) :: fmap_				!!.. objective function in space domain 
  end type

end module

