program main
  use bwi_kernel_mod
  implicit none

  type(dat_grid) :: dgrid
  type(pro_grid) :: pgrid
  type(vel_grid) :: vgrid
  type(img_grid) :: igrid
  type(hes_grid) :: hgrid
  type(cef_grid) :: cgrid
  type(bwi_ftag) :: ftag_
  logical        :: adj, add
  integer        :: stat

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()

  call from_param("add", add, .false.)

  stat = bwi_kernel_init(dgrid, pgrid, vgrid, igrid, hgrid, cgrid, ftag_)

  if (pgrid%mode=="tomfwd" .or. pgrid%mode=="tomadj") then
     if (pgrid%mode=="tomfwd") adj = .false.
     if (pgrid%mode=="tomadj") adj = .true.

     stat = bwi_kertom_oper(adj, add, ftag_%csou_, ftag_%crec_, ftag_%bvel_, ftag_%beps_, ftag_%bdel_, ftag_%dvel_, ftag_%deps_, ftag_%ddel_, ftag_%dimg_)

  else
     write(0,*)"ERROR: WRONG MODE, mode=tomfwd/tomadj"
     STOP
  end if

  call sep_end_prog()

  call exit()


end program
