program main
  use bwi_search_mod
  implicit none


  type(vel_grid)     :: vgrid
  character(len=6)   :: method
  logical            :: rstart
  integer            :: stat
  character(len=256) :: srhv_, gdov_, gdpv_
  character(len=256) :: srhe_, gdoe_, gdpe_

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()

  srhv_ = "srhv"
  gdov_ = "gdov"
  gdpv_ = "gdpv"

  srhe_ = "srhe"
  gdoe_ = "gdoe"
  gdpe_ = "gdpe"

  call from_param("method", method, "sdstep")
  call from_param("rstart", rstart, .false. )

  call auxinout(srhv_)
  call auxinout(gdov_)
  call auxinout(srhe_)
  call auxinout(gdoe_)

  call hinaxis(gdov_, vgrid%ax, 1)
  call hinaxis(gdov_, vgrid%ay, 2)
  call hinaxis(gdov_, vgrid%az, 3)

  if (method=="cgstep") then
!     write(0,*)"METHOD = CGSTEP"
     call auxinout(gdpv_)
     call auxinout(gdpe_)
  else
     call houaxis(srhv_, vgrid%ax, 1)
     call houaxis(srhv_, vgrid%ay, 2)
     call houaxis(srhv_, vgrid%az, 3)

  end if

  select case (method)
    case ("sdstep")
         stat = bwi_sdstep_oper(srhv_, srhe_, gdov_, gdoe_, vgrid)
    case ("cgstep")
         stat = bwi_cgstep_oper(srhv_,srhe_,gdov_,gdoe_,gdpv_,gdpe_,vgrid,rstart)
  end select

  call sep_end_prog()

  call exit()

end program
